package hu.oroscom.c1801;

import hu.oroscom.c1801.domain.Customer;
import hu.oroscom.c1801.domain.Setting;
import hu.oroscom.c1801.enumeration.SettingName;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

/**
 * Created by Norbert on 2014.10.30..
 */
public class ProjectProperties extends HashMap<Customer, HashMap<SettingName, Setting>> {

	public void load(List<Setting> settingList) {
		for (Setting setting : settingList) {
			HashMap<SettingName, Setting> settingNameSettingHashMap = get(setting.getCustomer());
			if (settingNameSettingHashMap == null) {
				settingNameSettingHashMap = new HashMap<>();
				put(setting.getCustomer(), settingNameSettingHashMap);
			}
			settingNameSettingHashMap.put(SettingName.fromString(setting.getName()), setting);
		}
	}

	public Setting getProperty(Customer customer, SettingName key) {
		if (get(customer) == null) {
			return null;
		}
		return get(customer).get(key);
	}

	public List<Setting> getProperty(Customer customer, SettingName[] key) {
		List<Setting> settingList = new ArrayList<>();
		HashMap<SettingName, Setting> settingNameSettingHashMap = get(customer);
		for (int i = 0; i < key.length; i++) {
			Setting setting = null;
			if (settingNameSettingHashMap != null) {
				setting = settingNameSettingHashMap.get(key[i]);
			}
			if (setting == null) {
				setting = new Setting(customer, key[i].toString(), null);
			}
			settingList.add(setting);
		}
		return settingList;
	}

	public void setProperty(Setting value) {
		HashMap<SettingName, Setting> settingNameSettingHashMap = get(value.getCustomer());
		if (settingNameSettingHashMap == null) {
			settingNameSettingHashMap = new HashMap<>();
			put(value.getCustomer(), settingNameSettingHashMap);
		}
		settingNameSettingHashMap.put(SettingName.fromString(value.getName()), value);
	}

	public void setProperty(List<Setting> value) {
		for (Setting setting : value) {
			setProperty(setting);
		}
	}
}
