package hu.oroscom.c1801;

import com.vaadin.server.CustomizedSystemMessages;
import com.vaadin.server.SystemMessages;
import com.vaadin.server.SystemMessagesInfo;
import com.vaadin.server.SystemMessagesProvider;
import org.vaadin.spring.i18n.I18N;

/**
 * Created by kollerk on 14. 10. 27..
 */
public class ProjectSystemMessagesProvider implements SystemMessagesProvider {

	@Override
	public SystemMessages getSystemMessages(SystemMessagesInfo systemMessagesInfo) {
		I18N i18n = (I18N) Application.getApplicationContext().getBean("i18n");
		CustomizedSystemMessages messages = new CustomizedSystemMessages();

		messages.setSessionExpiredCaption(i18n.get("SystemMessage.SessionExpiredCaption"));
		messages.setSessionExpiredMessage(i18n.get("SystemMessage.SessionExpiredMessage"));

		messages.setCommunicationErrorCaption(i18n.get("SystemMessage.CommunicationErrorCaption"));
		messages.setCommunicationErrorMessage(i18n.get("SystemMessage.CommunicationErrorMessage"));

		messages.setAuthenticationErrorCaption(i18n.get("SystemMessage.AuthenticationErrorCaption"));
		messages.setAuthenticationErrorMessage(i18n.get("SystemMessage.AuthenticationErrorMessage"));

		messages.setInternalErrorCaption(i18n.get("SystemMessage.InternalErrorCaption"));
		messages.setInternalErrorMessage(i18n.get("SystemMessage.InternalErrorMessage"));

//		messages.setOutOfSyncCaption(i18n.get("SystemMessage.OutOfSyncCaption"));
//		messages.setOutOfSyncCaption(i18n.get("SystemMessage.OutOfSyncMessage"));

		messages.setCookiesDisabledCaption(i18n.get("SystemMessage.CookiesDisabledCaption"));
		messages.setCookiesDisabledMessage(i18n.get("SystemMessage.CookiesDisabledMessage"));

		return messages;
	}
}
