package hu.oroscom.c1801.broadcaster;

import hu.oroscom.c1801.bean.BroadcastBean;

import java.io.Serializable;
import java.util.LinkedList;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

/**
 * Created by ifino on 2017.01.04..
 */
public class Broadcaster implements Serializable {
	static ExecutorService executorService = Executors.newSingleThreadExecutor();

	public interface BroadcastListener {
		void receiveBroadcast(BroadcastBean broadcastBean);
	}

	private static LinkedList<BroadcastListener> listeners = new LinkedList<>();

	public static synchronized void register(BroadcastListener listener) {
		listeners.add(listener);
	}

	public static synchronized void unregister(BroadcastListener listener) {
		listeners.remove(listener);
	}

	public static synchronized void broadcast(final BroadcastBean broadcastBean) {
		for (final BroadcastListener listener : listeners)
			executorService.execute(new Runnable() {
				@Override
				public void run() {
					listener.receiveBroadcast(broadcastBean);
				}
			});
	}
}
