package hu.oroscom.c1801.component;

import com.vaadin.ui.Component;
import com.vaadin.ui.ComponentContainer;
import com.vaadin.ui.CssLayout;
import com.vaadin.ui.GridLayout;

/**
 * Created by Norbert on 2014.10.03..
 */
public class MainLayout extends GridLayout {

	CssLayout menuArea = new CssLayout();
	CssLayout contentArea = new CssLayout();
	CssLayout infoArea = new CssLayout();

	public MainLayout() {
		setSizeFull();
		setRows(2);
		setColumns(2);

		infoArea.setPrimaryStyleName("valo-info");
		infoArea.setWidth(100, Unit.PERCENTAGE);
//		infoArea.setHeight(24, Unit.PIXELS);

		menuArea.setPrimaryStyleName("valo-menu");

		contentArea.setPrimaryStyleName("valo-content");
		contentArea.addStyleName("v-scrollable");
		contentArea.setSizeFull();

		addComponent(infoArea, 0, 0, 1, 0);
		addComponent(menuArea, 0, 1);
		addComponent(contentArea, 1, 1);
		setColumnExpandRatio(1, 1);
		setRowExpandRatio(1, 1);
	}

	public ComponentContainer getContentContainer() {
		return contentArea;
	}

	public void addMenu(Component menu) {
		menu.addStyleName("valo-menu-part");
		menuArea.addComponent(menu);
	}

	public void addInfo(Component info) {
		infoArea.addComponent(info);
	}
}
