package hu.oroscom.c1801.component.cell;

import com.vaadin.data.Property;
import com.vaadin.ui.Table;
import hu.oroscom.c1801.Application;
import org.vaadin.spring.events.EventBus;
import org.vaadin.spring.i18n.I18N;

/**
 * Created by Norbert on 2014.11.24..
 */
public abstract class AbstractCell implements Table.ColumnGenerator {

	protected I18N i18n;
	protected EventBus eventBus;

	protected AbstractCell() {
		this.i18n = (I18N) Application.getApplicationContext().getBean("i18n");
		this.eventBus = (EventBus) Application.getApplicationContext().getBean("uiEventBus");
	}

	protected boolean isVisible(Table source, Object itemId) {
		Property property = source.getItem(itemId).getItemProperty("isVisible");
		if (property == null || property.getValue() == null) {
			return true;
		} else {
			return (boolean) property.getValue();
		}
	}

	protected boolean isEnabled(Table source, Object itemId, Object columnId) {
		Property property = source.getItem(itemId).getItemProperty(columnId);
		if (property == null || property.getValue() == null) {
			return true;
		} else {
			return (boolean) property.getValue();
		}
	}

}
