package hu.oroscom.c1801.component.cell;

import com.vaadin.ui.Button;
import com.vaadin.ui.Table;

/**
 * Created by Norbert on 2014.12.10..
 */
public class ApproveCell extends AbstractCell {

	private Button.ClickListener approveButtonClickListener;
	private boolean isApproveCellEnabled;

	public ApproveCell(Button.ClickListener approveButtonClickListener, boolean isApproveCellEnabled) {
		this.approveButtonClickListener = approveButtonClickListener;
		this.isApproveCellEnabled = isApproveCellEnabled;
	}

	@Override
	public Object generateCell(Table source, Object itemId, Object columnId) {
		if (isApproveCellEnabled) {
			boolean approved = (boolean) source.getItem(itemId).getItemProperty(columnId).getValue();
			if (approved) {
				return null;
			}
			Button button = new Button(i18n.get("ApproveCell.approve"), approveButtonClickListener);
			if (source.getItem(itemId).getItemProperty("id") != null) {
				button.setData(source.getItem(itemId).getItemProperty("id").getValue());
			} else { //ConflictBooking
				button.setData(source.getItem(itemId).getItemProperty("conflictId").getValue());
			}
			return button;
		} else {
			return null;
		}
	}
}
