package hu.oroscom.c1801.component.cell;

import com.vaadin.server.Resource;
import com.vaadin.ui.Button;
import com.vaadin.ui.Label;
import com.vaadin.ui.Table;
import com.vaadin.ui.themes.ValoTheme;


/**
 * Created by Norbert on 2014.11.24..
 */
public class ButtonCell extends AbstractCell {

	private Button.ClickListener clickListener;
	private Resource icon;

	public ButtonCell(Resource icon, Button.ClickListener clickListener) {
		this.icon = icon;
		this.clickListener = clickListener;
	}

	@Override
	public Object generateCell(Table source, Object itemId, Object columnId) {
		if (isEnabled(source, itemId, "isButtonCellEnabled")) {
			Button button = new Button(icon);
			button.setData(itemId);
			button.addClickListener(clickListener);
			button.addStyleName(ValoTheme.BUTTON_ICON_ONLY);
			button.addStyleName(ValoTheme.BUTTON_SMALL);
			return button;
		}
		return new Label("");
	}
}
