package hu.oroscom.c1801.component.cell;

import com.vaadin.addon.tableexport.ExportableColumnGenerator;
import com.vaadin.data.Property;
import com.vaadin.ui.Button;
import com.vaadin.ui.Label;
import com.vaadin.ui.Table;
import com.vaadin.ui.themes.ValoTheme;
import hu.oroscom.c1801.component.table.TableObject;

/**
 * Created by Norbert on 2015.06.16..
 */
public class CountFilterCell extends AbstractCell implements ExportableColumnGenerator {

	protected Button.ClickListener clickListener;
	private Table table;

	public CountFilterCell(Button.ClickListener clickListener) {
		this.clickListener = clickListener;
	}

	@Override
	public Object generateCell(Table table, Object itemId, Object columnId) {
		this.table = table;
		Integer count = (Integer) table.getItem(itemId).getItemProperty(columnId).getValue();
		if (count == null || count <= 0) {
			return null;
		}

		Button buttonEdit = new Button(count.toString());
		buttonEdit.setData(new TableObject(itemId, columnId));
		buttonEdit.addClickListener(clickListener);
		buttonEdit.addStyleName(ValoTheme.BUTTON_LINK);
		buttonEdit.addStyleName(ValoTheme.BUTTON_SMALL);
		return buttonEdit;
	}

	@Override
	public Property getGeneratedProperty(Object itemId, Object columnId) {
		Integer count = (Integer) table.getItem(itemId).getItemProperty(columnId).getValue();
		if (count <= 0) {
			return null;
		} else {
			return new Label(count.toString());
		}
	}

	@Override
	public Class<?> getType() {
		return String.class;
	}
}
