package hu.oroscom.c1801.component.cell;

import com.vaadin.ui.Button;
import com.vaadin.ui.Label;
import com.vaadin.ui.Table;
import com.vaadin.ui.themes.ValoTheme;
import org.joda.time.DateTime;
import org.joda.time.format.DateTimeFormat;
import org.joda.time.format.DateTimeFormatter;

/**
 * Created by Norbert on 2014.11.24..
 */
public class DateEditCell extends EditCell {

	private static final DateTimeFormatter DATE_TIME_FORMATTER = DateTimeFormat.forPattern("yyyy.MM.dd");

	public DateEditCell(Button.ClickListener clickListener) {
		super(clickListener);
	}

	@Override
	public Object generateCell(Table source, Object itemId, Object columnId) {
		if (!isVisible(source, itemId)) {
			return null;
		}

		String caption = DATE_TIME_FORMATTER.print((DateTime) source.getItem(itemId).getItemProperty(columnId).getValue());
		if (isEnabled(source, itemId, "isDateEditCellEnabled")) {
			Button buttonEdit = new Button(caption);
			buttonEdit.setData(itemId);
			buttonEdit.addClickListener(clickListener);
			buttonEdit.addStyleName(ValoTheme.BUTTON_LINK);
			return buttonEdit;
		} else {
			return new Label(caption);
		}
	}
}
