package hu.oroscom.c1801.component.cell;

import com.vaadin.addon.tableexport.ExportableColumnGenerator;
import com.vaadin.data.Property;
import com.vaadin.server.VaadinSession;
import com.vaadin.ui.Label;
import com.vaadin.ui.Table;
import org.joda.time.DateTime;
import org.joda.time.format.DateTimeFormat;
import org.joda.time.format.DateTimeFormatter;

/**
 * Created by kollerk on 14. 12. 03..
 */
public class DateTimeFormatCell extends AbstractCell implements ExportableColumnGenerator {
	private static DateTimeFormatter dateTimeFormatter = DateTimeFormat.shortDateTime().withLocale(VaadinSession.getCurrent().getLocale());
	private Table source;
	private boolean nullable = false;

	public DateTimeFormatCell() {

	}

	public DateTimeFormatCell(boolean nullable) {
		this.nullable = nullable;
	}

	@Override
	public Object generateCell(Table source, Object itemId, Object columnId) {
		this.source = source;
		if (!dateTimeFormatter.getLocale().equals(VaadinSession.getCurrent().getLocale())) {
			dateTimeFormatter = DateTimeFormat.shortDateTime().withLocale(VaadinSession.getCurrent().getLocale());
		}

		String formattedDateTime;
		DateTime dateTime = (DateTime) source.getItem(itemId).getItemProperty(columnId).getValue();
		if (nullable) {
			if (dateTime == null) {
				formattedDateTime = "";
			} else {
				formattedDateTime = dateTimeFormatter.print(dateTime);
			}
		} else {
			formattedDateTime = dateTimeFormatter.print(dateTime);
		}

		return new Label(formattedDateTime);
	}

	@Override
	public Property getGeneratedProperty(Object itemId, Object columnId) {
		if (!dateTimeFormatter.getLocale().equals(VaadinSession.getCurrent().getLocale())) {
			dateTimeFormatter = DateTimeFormat.shortDateTime().withLocale(VaadinSession.getCurrent().getLocale());
		}

		String formattedDateTime;
		DateTime dateTime = (DateTime) source.getItem(itemId).getItemProperty(columnId).getValue();
		if (nullable) {
			if (dateTime == null) {
				formattedDateTime = "";
			} else {
				formattedDateTime = dateTimeFormatter.print(dateTime);
			}
		} else {
			formattedDateTime = dateTimeFormatter.print(dateTime);
		}

		return new Label(formattedDateTime);
	}

	@Override
	public Class<?> getType() {
		return String.class;
	}
}
