package hu.oroscom.c1801.component.cell;

import com.vaadin.server.FileDownloader;
import com.vaadin.server.FontAwesome;
import com.vaadin.server.StreamResource;
import com.vaadin.ui.Button;
import com.vaadin.ui.Table;
import com.vaadin.ui.themes.ValoTheme;

import java.io.*;
import java.nio.charset.Charset;

/**
 * Created by kollerk on 15. 02. 24..
 */
public class DownloadCSVCell extends AbstractCell {

	@Override
	public Object generateCell(Table source, Object itemId, Object columnId) {
		if (isEnabled(source, itemId, "isEditCellEnabled")) {
			Button buttonDownload = new Button(FontAwesome.DOWNLOAD);
			buttonDownload.setData(itemId);
			buttonDownload.addStyleName(ValoTheme.BUTTON_ICON_ONLY);
			buttonDownload.addStyleName(ValoTheme.BUTTON_DANGER);
//			buttonDownload.setDisableOnClick(true);

			StreamResource streamResource = createResource(source.getItem(itemId).getItemProperty(columnId).getValue().toString());
			FileDownloader fileDownloader = new FileDownloader(streamResource);
			fileDownloader.extend(buttonDownload);

			return buttonDownload;
		}
		return null;
	}

	private StreamResource createResource(final String csvString) {
		return new StreamResource(new StreamResource.StreamSource() {
			@Override
			public InputStream getStream() {
				try {

//					byte[] csvBytes = csvString.getBytes(Charset.forName("ISO-8859-2"));
					ByteArrayOutputStream arrayOutputStream = new ByteArrayOutputStream();
					BufferedWriter bufferedWriter = new BufferedWriter(new OutputStreamWriter(arrayOutputStream));
					bufferedWriter.write(csvString);
					bufferedWriter.flush();
					bufferedWriter.close();
					return new ByteArrayInputStream(arrayOutputStream.toString().getBytes(Charset.forName("ISO-8859-2")));
				} catch (Throwable e) {
					e.printStackTrace();
				}

				return null;
			}
		}, "excel-export-log.csv");
	}
}
