package hu.oroscom.c1801.component.cell;

import com.vaadin.addon.tableexport.ExportableColumnGenerator;
import com.vaadin.data.Property;
import com.vaadin.ui.Button;
import com.vaadin.ui.Label;
import com.vaadin.ui.Table;
import com.vaadin.ui.themes.ValoTheme;


/**
 * Created by Norbert on 2014.11.24..
 */
public class EditCell extends AbstractCell implements ExportableColumnGenerator {

	protected Button.ClickListener clickListener;
	private Table source;

	public EditCell(Button.ClickListener clickListener) {
		this.clickListener = clickListener;
	}

	@Override
	public Object generateCell(Table source, Object itemId, Object columnId) {
		this.source = source;
		Object caption = source.getItem(itemId).getItemProperty(columnId).getValue();
		if (isEnabled(source, itemId, "isEditCellEnabled")) {
			Button buttonEdit = new Button(caption == null ? null : caption.toString());
			buttonEdit.setData(itemId);
			buttonEdit.addClickListener(clickListener);
			buttonEdit.addStyleName(ValoTheme.BUTTON_LINK);
			buttonEdit.addStyleName(ValoTheme.BUTTON_SMALL);
			return buttonEdit;
		}
		return new Label(caption == null ? null : caption.toString());
	}

	@Override
	public Property getGeneratedProperty(Object itemId, Object columnId) {
		Object caption = source.getItem(itemId).getItemProperty(columnId).getValue();
		return new Label(caption == null ? null : caption.toString());
	}

	@Override
	public Class<?> getType() {
		return String.class;
	}
}
