package hu.oroscom.c1801.component.cell;

import com.vaadin.addon.tableexport.ExportableColumnGenerator;
import com.vaadin.data.Property;
import com.vaadin.server.VaadinSession;
import com.vaadin.ui.Button;
import com.vaadin.ui.Label;
import com.vaadin.ui.Table;
import com.vaadin.ui.themes.ValoTheme;
import org.joda.time.DateTime;
import org.joda.time.format.DateTimeFormat;
import org.joda.time.format.DateTimeFormatter;


/**
 * Created by Norbert on 2014.11.24..
 */
public class EditDateTimeFormatCell extends AbstractCell implements ExportableColumnGenerator {
	private static DateTimeFormatter dateTimeFormatter = DateTimeFormat.shortDateTime().withLocale(VaadinSession.getCurrent().getLocale());
	private Button.ClickListener clickListener;
	private Table source;

	public EditDateTimeFormatCell(Button.ClickListener clickListener) {
		this.clickListener = clickListener;
	}

	@Override
	public Object generateCell(Table source, Object itemId, Object columnId) {
		this.source = source;
		if (!dateTimeFormatter.getLocale().equals(VaadinSession.getCurrent().getLocale())) {
			dateTimeFormatter = DateTimeFormat.shortDateTime().withLocale(VaadinSession.getCurrent().getLocale());
		}

		String formattedDateTime;
		DateTime dateTime = (DateTime) source.getItem(itemId).getItemProperty(columnId).getValue();
		if (dateTime == null) {
			formattedDateTime = "";
		} else {
			formattedDateTime = dateTimeFormatter.print(dateTime);
		}

		if (isEnabled(source, itemId, "isEditCellEnabled")) {
			Button buttonEdit = new Button(formattedDateTime);
			buttonEdit.setData(itemId);
			buttonEdit.addClickListener(clickListener);
			buttonEdit.addStyleName(ValoTheme.BUTTON_LINK);
			buttonEdit.addStyleName(ValoTheme.BUTTON_SMALL);
			return buttonEdit;
		}
		return new Label(formattedDateTime);
	}

	@Override
	public Property getGeneratedProperty(Object itemId, Object columnId) {
		if (!dateTimeFormatter.getLocale().equals(VaadinSession.getCurrent().getLocale())) {
			dateTimeFormatter = DateTimeFormat.shortDateTime().withLocale(VaadinSession.getCurrent().getLocale());
		}

		String formattedDateTime;
		DateTime dateTime = (DateTime) source.getItem(itemId).getItemProperty(columnId).getValue();
		if (dateTime == null) {
			formattedDateTime = "";
		} else {
			formattedDateTime = dateTimeFormatter.print(dateTime);
		}

		return new Label(formattedDateTime);
	}

	@Override
	public Class<?> getType() {
		return String.class;
	}
}
