package hu.oroscom.c1801.component.cell;

import com.vaadin.data.Property;
import com.vaadin.ui.CheckBox;
import com.vaadin.ui.Table;

import java.util.Set;

/**
 * Created by Norbert on 2014.11.24..
 */
public class MultiSelectCell extends AbstractCell {
	private Set<Object> selectedItemIds;

	public MultiSelectCell(Set<Object> selectedItemIds) {
		this.selectedItemIds = selectedItemIds;
	}

	@Override
	public Object generateCell(Table source, final Object itemId, Object columnId) {
		if (!isVisible(source, itemId)) {
			return null;
		}

		CheckBox checkBox = new CheckBox();
		Object o = source.getItem(itemId).getItemProperty(columnId).getValue();
		boolean b = o == null ? false : (boolean) o;
		checkBox.setValue(b);
		checkBox.addValueChangeListener(new Property.ValueChangeListener() {
			@Override
			public void valueChange(Property.ValueChangeEvent valueChangeEvent) {
				if (selectedItemIds.contains(itemId)) {
					selectedItemIds.remove(itemId);
				} else {
					selectedItemIds.add(itemId);
				}
			}
		});

		return checkBox;
	}
}
