package hu.oroscom.c1801.component.cell;

import com.vaadin.addon.tableexport.ExportableColumnGenerator;
import com.vaadin.data.Property;
import com.vaadin.ui.Label;
import com.vaadin.ui.Table;
import hu.oroscom.c1801.enumeration.PatientStatus;


public class PatientStatusCell extends AbstractCell implements ExportableColumnGenerator {
	private Table source;

	@Override
	public Object generateCell(Table source, Object itemId, Object columnId) {
		this.source = source;
		if (!isVisible(source, itemId)) {
			return null;
		}
//		return new Label(Boolean.TRUE.equals(source.getContainerDataSource().getContainerProperty(itemId, columnId).getValue() == EntityStatus.ACTIVE) ? EntityStatus.ACTIVE.getCaption() : EntityStatus.INACTIVE.getCaption());
		PatientStatus patientStatus = (PatientStatus) source.getContainerDataSource().getContainerProperty(itemId, columnId).getValue();
		return new Label(patientStatus.getCaption());
	}

	@Override
	public Property getGeneratedProperty(Object itemId, Object columnId) {
		PatientStatus patientStatus = (PatientStatus) source.getItem(itemId).getItemProperty(columnId).getValue();
		return new Label(patientStatus == null ? null : patientStatus.getCaption());
	}

	@Override
	public Class<?> getType() {
		return String.class;
	}
}
