package hu.oroscom.c1801.component.cell;

import com.vaadin.server.FontAwesome;
import com.vaadin.server.Resource;
import com.vaadin.ui.Button;
import com.vaadin.ui.Label;
import com.vaadin.ui.Table;
import com.vaadin.ui.themes.ValoTheme;


/**
 * Created by Norbert on 2014.11.24..
 */
public class PermissionCell extends AbstractCell {

	private Button.ClickListener clickListener;

	public PermissionCell(Button.ClickListener clickListener) {
		this.clickListener = clickListener;
	}

	@Override
	public Object generateCell(Table source, Object itemId, Object columnId) {
		Boolean hasPermission = (Boolean) source.getItem(itemId).getItemProperty(columnId).getValue();
		if (isEnabled(source, itemId, "isPermissionCellEnabled")) {
			Resource icon = hasPermission ? FontAwesome.REMOVE : null;
			Button buttonEdit = new Button(icon);
			buttonEdit.setData(new Object[]{itemId, columnId});
			buttonEdit.addClickListener(clickListener);
			buttonEdit.addStyleName(ValoTheme.BUTTON_ICON_ONLY);
			buttonEdit.addStyleName(ValoTheme.BUTTON_SMALL);
			return buttonEdit;
		}
		return new Label(hasPermission ? "X" : "");
	}
}
