package hu.oroscom.c1801.component.cell;

import com.vaadin.addon.tableexport.ExportableColumnGenerator;
import com.vaadin.data.Property;
import com.vaadin.ui.Label;
import com.vaadin.ui.Table;
import hu.oroscom.c1801.enumeration.ServiceManagementNature;

/**
 * Created by Norbert on 2014.11.24..
 */
public class ServiceManagementNatureCell extends AbstractCell implements ExportableColumnGenerator {
	private Table source;

	@Override
	public Object generateCell(Table source, Object itemId, Object columnId) {
		this.source = source;
		if (!isVisible(source, itemId)) {
			return null;
		}
		ServiceManagementNature serviceManagementNature = (ServiceManagementNature) source.getContainerDataSource().getContainerProperty(itemId, columnId).getValue();
		return new Label(serviceManagementNature.getCaption());
	}

	@Override
	public Property getGeneratedProperty(Object itemId, Object columnId) {
		ServiceManagementNature serviceManagementNature = (ServiceManagementNature) source.getItem(itemId).getItemProperty(columnId).getValue();
		return new Label(serviceManagementNature == null ? null : serviceManagementNature.getCaption());
	}

	@Override
	public Class<?> getType() {
		return String.class;
	}
}
