package hu.oroscom.c1801.component.cell;

import com.vaadin.addon.tableexport.ExportableColumnGenerator;
import com.vaadin.data.Property;
import com.vaadin.ui.Label;
import com.vaadin.ui.Table;
import hu.oroscom.c1801.enumeration.EntityStatus;

/**
 * Created by Norbert on 2014.11.24..
 */
public class StatusCell extends AbstractCell implements ExportableColumnGenerator {
	private Table source;

	@Override
	public Object generateCell(Table source, Object itemId, Object columnId) {
		this.source = source;
		if (!isVisible(source, itemId)) {
			return null;
		}
//		return new Label(Boolean.TRUE.equals(source.getContainerDataSource().getContainerProperty(itemId, columnId).getValue() == EntityStatus.ACTIVE) ? EntityStatus.ACTIVE.getCaption() : EntityStatus.INACTIVE.getCaption());
		EntityStatus entityStatus = (EntityStatus) source.getContainerDataSource().getContainerProperty(itemId, columnId).getValue();
		return new Label(entityStatus.getCaption());
	}

	@Override
	public Property getGeneratedProperty(Object itemId, Object columnId) {
		EntityStatus entityStatus = (EntityStatus) source.getItem(itemId).getItemProperty(columnId).getValue();
		return new Label(entityStatus == null ? null : entityStatus.getCaption());
	}

	@Override
	public Class<?> getType() {
		return String.class;
	}
}
