package hu.oroscom.c1801.component.cell;

import com.vaadin.addon.tableexport.ExportableColumnGenerator;
import com.vaadin.data.Property;
import com.vaadin.ui.Label;
import com.vaadin.ui.Table;
import hu.oroscom.c1801.enumeration.StudyEntryType;

public class StudyEntryTypeCell extends AbstractCell implements ExportableColumnGenerator {
	private Table source;

	@Override
	public Object generateCell(Table source, Object itemId, Object columnId) {
		this.source = source;
		if (!isVisible(source, itemId)) {
			return null;
		}
		StudyEntryType studyEntryType = (StudyEntryType) source.getContainerDataSource().getContainerProperty(itemId, columnId).getValue();
		return new Label(studyEntryType.getCaption());
	}

	@Override
	public Property getGeneratedProperty(Object itemId, Object columnId) {
		StudyEntryType studyEntryType = (StudyEntryType) source.getItem(itemId).getItemProperty(columnId).getValue();
		return new Label(studyEntryType == null ? null : studyEntryType.getCaption());
	}

	@Override
	public Class<?> getType() {
		return String.class;
	}
}
