package hu.oroscom.c1801.component.cell;

import com.vaadin.addon.tableexport.ExportableColumnGenerator;
import com.vaadin.data.Property;
import com.vaadin.ui.Label;
import com.vaadin.ui.Table;
import com.vaadin.ui.TextField;
import com.vaadin.ui.themes.ValoTheme;

/**
 * Created by Norbert on 2014.11.24..
 */
public class TextEditCell extends AbstractCell implements ExportableColumnGenerator {
	private Property.ValueChangeListener valueChangeListener;
	private Table source;

	public TextEditCell(Property.ValueChangeListener valueChangeListener) {
		this.valueChangeListener = valueChangeListener;
	}

	@Override
	public Object generateCell(Table source, Object itemId, Object columnId) {
		this.source = source;
		if (!isVisible(source, itemId)) {
			return null;
		}

		Object value = source.getItem(itemId).getItemProperty(columnId).getValue();
		String textFieldValue = value == null ? "" : (String) value;

		TextField textField = new TextField();
		textField.addStyleName(ValoTheme.TEXTFIELD_TINY);
		textField.setValue(textFieldValue);
		textField.setData(itemId);
		textField.addValueChangeListener(valueChangeListener);

		return textField;
	}

	@Override
	public Property getGeneratedProperty(Object itemId, Object columnId) {
		Object value = source.getItem(itemId).getItemProperty(columnId).getValue();
		String textFieldValue = value == null ? "" : (String) value;
		return new Label(textFieldValue);
	}

	@Override
	public Class<?> getType() {
		return String.class;
	}
}
