package hu.oroscom.c1801.component.cell;

import com.vaadin.ui.Label;
import com.vaadin.ui.Table;
import org.joda.time.DateTime;
import org.joda.time.format.DateTimeFormat;
import org.joda.time.format.DateTimeFormatter;

/**
 * Created by Norbert on 2014.11.26..
 */
public class TimeCell extends AbstractCell {

	private static final DateTimeFormatter DATE_TIME_FORMATTER = DateTimeFormat.forPattern("HH:mm");

	@Override
	public Object generateCell(Table source, Object itemId, Object columnId) {
		if (!isVisible(source, itemId)) {
			return null;
		}
		String startDate = DATE_TIME_FORMATTER.print((DateTime) source.getItem(itemId).getItemProperty("period.startDate").getValue());
		String endDate = DATE_TIME_FORMATTER.print((DateTime) source.getItem(itemId).getItemProperty("period.endDate").getValue());
		return new Label(startDate + " - " + endDate);
	}
}
