package hu.oroscom.c1801.component.cell;

import com.vaadin.addon.tableexport.ExportableColumnGenerator;
import com.vaadin.data.Property;
import com.vaadin.ui.Label;
import com.vaadin.ui.Table;
import hu.oroscom.c1801.domain.User;

/**
 * Created by Norbert on 2014.12.10..
 */
public class UserCell extends AbstractCell implements ExportableColumnGenerator {
	private Table source;

	@Override
	public Object generateCell(Table source, Object itemId, Object columnId) {
		this.source = source;
		User user = (User) source.getItem(itemId).getItemProperty(columnId).getValue();

		if (user != null) {
			user.setDisplayName();
		}

		return new Label(user == null ? "" : user.getDisplayName());
	}

	@Override
	public Property getGeneratedProperty(Object itemId, Object columnId) {
		User user = (User) source.getItem(itemId).getItemProperty(columnId).getValue();

		if (user != null) {
			user.setDisplayName();
		}

		return new Label(user == null ? "" : user.getDisplayName());
	}

	@Override
	public Class<?> getType() {
		return String.class;
	}
}
