package hu.oroscom.c1801.component.combobox;

import com.vaadin.data.util.BeanItemContainer;
import com.vaadin.shared.ui.combobox.FilteringMode;
import com.vaadin.ui.ComboBox;
import hu.oroscom.c1801.enumeration.Gender;


public class GenderComboBox extends ComboBox {

	public GenderComboBox(String caption) {
		super(caption);

		setItemCaptionPropertyId("caption");
		setRequired(false);
		setNullSelectionAllowed(true);
		setFilteringMode(FilteringMode.CONTAINS);

		final BeanItemContainer<Gender> beanItemContainer = new BeanItemContainer<>(Gender.class);
		for (Gender gender : Gender.values()) {
			beanItemContainer.addBean(gender);
		}

		setContainerDataSource(beanItemContainer);
	}
}
