package hu.oroscom.c1801.component.combobox;

import com.vaadin.data.util.BeanItemContainer;
import com.vaadin.shared.ui.combobox.FilteringMode;
import com.vaadin.ui.ComboBox;
import hu.oroscom.c1801.enumeration.PatientStatus;


public class PatientStatusComboBox extends ComboBox {

	public PatientStatusComboBox(String caption) {
		super(caption);

		setItemCaptionPropertyId("caption");
		setRequired(false);
		setNullSelectionAllowed(true);
		setFilteringMode(FilteringMode.CONTAINS);

		final BeanItemContainer<PatientStatus> beanItemContainer = new BeanItemContainer<>(PatientStatus.class);
		for (PatientStatus patientStatus : PatientStatus.values()) {
			beanItemContainer.addBean(patientStatus);
		}

		setContainerDataSource(beanItemContainer);
	}
}
