package hu.oroscom.c1801.component.combobox;

import com.vaadin.data.util.BeanItemContainer;
import com.vaadin.ui.ComboBox;
import hu.oroscom.c1801.enumeration.EntityStatus;

/**
 * Created by kollerk on 14. 11. 17..
 */
public class StatusComboBox extends ComboBox {

	public StatusComboBox(String caption) {
		super(caption);

		setItemCaptionPropertyId("caption");
		setRequired(true);
		setNullSelectionAllowed(false);

		final BeanItemContainer<EntityStatus> entityStatusBeanItemContainer = new BeanItemContainer<EntityStatus>(EntityStatus.class);
		for (EntityStatus entityStatus : EntityStatus.values()) {
			if (entityStatus != EntityStatus.DELETED) {
				entityStatusBeanItemContainer.addBean(entityStatus);
			}
		}

		setContainerDataSource(entityStatusBeanItemContainer);

	}


}
