package hu.oroscom.c1801.component.combobox;

import com.vaadin.data.util.BeanItemContainer;
import com.vaadin.shared.ui.combobox.FilteringMode;
import com.vaadin.ui.ComboBox;
import hu.oroscom.c1801.enumeration.EntityStatus;
import hu.oroscom.c1801.enumeration.Venue;

/**
 * Created by kollerk on 14. 11. 17..
 */
public class VenueComboBox extends ComboBox {

	public VenueComboBox(String caption) {
		super(caption);

		setItemCaptionPropertyId("caption");
		setRequired(false);
		setNullSelectionAllowed(true);
		setFilteringMode(FilteringMode.CONTAINS);

		final BeanItemContainer<Venue> venueBeanItemContainer = new BeanItemContainer<Venue>(Venue.class);
		for (Venue venue : Venue.values()) {
			venueBeanItemContainer.addBean(venue);
		}

		setContainerDataSource(venueBeanItemContainer);
	}
}
