package hu.oroscom.c1801.component.combobox;

import com.vaadin.data.util.BeanItemContainer;
import com.vaadin.shared.ui.combobox.FilteringMode;
import com.vaadin.ui.ComboBox;
import hu.oroscom.c1801.enumeration.YesNo;


public class YesNoComboBox extends ComboBox {

	public YesNoComboBox(String caption) {
		super(caption);

		setItemCaptionPropertyId("caption");
		setRequired(false);
		setNullSelectionAllowed(true);
		setFilteringMode(FilteringMode.CONTAINS);

		final BeanItemContainer<YesNo> beanItemContainer = new BeanItemContainer<>(YesNo.class);
		for (YesNo yesNo : YesNo.values()) {
			beanItemContainer.addBean(yesNo);
		}

		setContainerDataSource(beanItemContainer);
	}
}
