package hu.oroscom.c1801.component.datefield;

import com.vaadin.data.Property;
import com.vaadin.data.Validator;
import hu.oroscom.c1801.component.property.JodaDateTimeProperty;
import hu.oroscom.c1801.converter.DateToJodaDateConverter;
import hu.oroscom.c1801.widgetset.CustomDateField;
import org.joda.time.DateTime;

import java.util.Date;

/**
 * Created by kollerk on 14. 11. 21..
 */
public class JodaDateField extends CustomDateField {

	public JodaDateField() {
	}

	public JodaDateField(String caption) {
		super(caption);
	}

	public JodaDateField(String caption, Property dataSource) {
		super(caption, dataSource);
	}

	public JodaDateField(Property dataSource) throws IllegalArgumentException {
		super(dataSource);
	}

	public JodaDateField(String caption, Date value) {
		super(caption, value);
	}

	public JodaDateField(String caption, DateTime value) {
		super(caption, value.toDate());
	}

	@Override
	public void setPropertyDataSource(Property newDataSource) {

		if (newDataSource.getType().equals(DateTime.class)) {
			super.setPropertyDataSource(new JodaDateTimeProperty(newDataSource));
		} else {
			super.setPropertyDataSource(newDataSource);
		}
	}

	public DateTime getJodaValue() {
		return new DateTime(super.getValue());
	}

	public void setJodaValue(DateTime newFieldValue) {
		super.setValue(newFieldValue == null ? null : newFieldValue.toDate());
	}

	@Override
	public void validate() throws Validator.InvalidValueException {
		setConverter(Date.class);
		super.validate();
		setConverter(new DateToJodaDateConverter());
	}
}
