package hu.oroscom.c1801.component.form;

import com.vaadin.data.Container;
import com.vaadin.data.fieldgroup.BeanFieldGroup;
import com.vaadin.data.fieldgroup.FieldGroup;
import com.vaadin.data.util.converter.Converter;
import com.vaadin.shared.ui.datefield.Resolution;
import com.vaadin.ui.Notification;
import com.vaadin.ui.TextArea;
import hu.oroscom.c1801.component.datefield.JodaDateField;
import hu.oroscom.c1801.converter.DateToJodaDateConverter;
import hu.oroscom.c1801.domain.Complaint;
import hu.oroscom.c1801.service.ComplaintService;

import java.util.Date;

public class ComplaintForm extends BaseForm<Complaint, ComplaintService> {
	private Complaint complaint;

	public ComplaintForm(Complaint entity, boolean isWindowedForm, Container... container) {
		super(entity, isWindowedForm, container);
	}

	@Override
	public void initMemberFields(final BeanFieldGroup<Complaint> beanFieldGroup, Container... container) {
		complaint = beanFieldGroup.getItemDataSource().getBean();

		JodaDateField dateTimeJodaDateField = new JodaDateField(i18n.get("Complaint.dateTime")) {
			@Override
			protected Date handleUnparsableDateString(String dateString) throws Converter.ConversionException {
				Notification.show(i18n.get("DateField.invalidDateFormat"), Notification.Type.WARNING_MESSAGE);
				throw new Converter.ConversionException(i18n.get("DateField.invalidDateFormat"));
			}
		};
		dateTimeJodaDateField.setResolution(Resolution.MINUTE);
		dateTimeJodaDateField.setConverter(new DateToJodaDateConverter());
		beanFieldGroup.bind(dateTimeJodaDateField, "dateTime");
		formLayout.addComponent(dateTimeJodaDateField);

		formLayout.addComponent(beanFieldGroup.buildAndBind(i18n.get("Complaint.description"), "description", TextArea.class));

		beanFieldGroup.addCommitHandler(new FieldGroup.CommitHandler() {
			@Override
			public void preCommit(FieldGroup.CommitEvent commitEvent) throws FieldGroup.CommitException {

			}

			@Override
			public void postCommit(FieldGroup.CommitEvent commitEvent) throws FieldGroup.CommitException {

			}
		});
	}
}
