package hu.oroscom.c1801.component.form;

import com.vaadin.data.Container;
import com.vaadin.data.fieldgroup.BeanFieldGroup;
import com.vaadin.data.fieldgroup.FieldGroup;
import com.vaadin.data.util.converter.Converter;
import com.vaadin.shared.ui.datefield.Resolution;
import com.vaadin.ui.Notification;
import com.vaadin.ui.TextArea;
import hu.oroscom.c1801.component.datefield.JodaDateField;
import hu.oroscom.c1801.converter.DateToJodaDateConverter;
import hu.oroscom.c1801.domain.IntolerantMaterial;
import hu.oroscom.c1801.service.IntolerantMaterialService;
import hu.oroscom.c1801.widgetset.NumberField;

import java.util.Date;

public class IntolerantMaterialForm extends BaseForm<IntolerantMaterial, IntolerantMaterialService> {
	private IntolerantMaterial intolerantMaterial;

	public IntolerantMaterialForm(IntolerantMaterial entity, boolean isWindowedForm, Container... container) {
		super(entity, isWindowedForm, container);
	}

	@Override
	public void initMemberFields(final BeanFieldGroup<IntolerantMaterial> beanFieldGroup, Container... container) {
		intolerantMaterial = beanFieldGroup.getItemDataSource().getBean();

		formLayout.addComponent(beanFieldGroup.buildAndBind(i18n.get("IntolerantMaterial.name"), "name"));
		formLayout.addComponent(beanFieldGroup.buildAndBind(i18n.get("IntolerantMaterial.quantity"), "quantity", NumberField.class));

		JodaDateField dateTimeJodaDateField = new JodaDateField(i18n.get("IntolerantMaterial.dateTime")) {
			@Override
			protected Date handleUnparsableDateString(String dateString) throws Converter.ConversionException {
				Notification.show(i18n.get("DateField.invalidDateFormat"), Notification.Type.WARNING_MESSAGE);
				throw new Converter.ConversionException(i18n.get("DateField.invalidDateFormat"));
			}
		};
		dateTimeJodaDateField.setResolution(Resolution.MINUTE);
		dateTimeJodaDateField.setConverter(new DateToJodaDateConverter());
		beanFieldGroup.bind(dateTimeJodaDateField, "dateTime");
		formLayout.addComponent(dateTimeJodaDateField);

		formLayout.addComponent(beanFieldGroup.buildAndBind(i18n.get("IntolerantMaterial.description"), "description", TextArea.class));

		beanFieldGroup.addCommitHandler(new FieldGroup.CommitHandler() {
			@Override
			public void preCommit(FieldGroup.CommitEvent commitEvent) throws FieldGroup.CommitException {

			}

			@Override
			public void postCommit(FieldGroup.CommitEvent commitEvent) throws FieldGroup.CommitException {

			}
		});
	}
}
