package hu.oroscom.c1801.component.form;

import com.vaadin.data.Container;
import com.vaadin.data.fieldgroup.BeanFieldGroup;
import com.vaadin.data.fieldgroup.PropertyId;
import com.vaadin.data.util.BeanItemContainer;
import com.vaadin.ui.ComboBox;
import hu.oroscom.c1801.domain.Report;
import hu.oroscom.c1801.enumeration.ReportCategory;
import hu.oroscom.c1801.service.ReportService;

import java.util.EnumSet;

/**
 * Created by kollerk on 15. 02. 24..
 */
public class ReportForm extends BaseForm<Report, ReportService> {

	@PropertyId("reportCategory")
	private ComboBox reportCategoryComboBox;

	public ReportForm(Report entity, boolean isWindowedForm, Container... container) {
		super(entity, isWindowedForm, container);
	}

	@Override
	public void initMemberFields(BeanFieldGroup<Report> beanFieldGroup, Container... container) {
		formLayout.addComponent(beanFieldGroup.buildAndBind(i18n.get("Report.name"), "name"));

		final BeanItemContainer<ReportCategory> reportCategoryBeanItemContainer = new BeanItemContainer<>(ReportCategory.class);
		reportCategoryBeanItemContainer.addAll(EnumSet.allOf(ReportCategory.class));

		reportCategoryComboBox = new ComboBox(i18n.get("Report.reportCategory"), reportCategoryBeanItemContainer);
		reportCategoryComboBox.setItemCaptionPropertyId("caption");
		reportCategoryComboBox.setRequired(true);
		reportCategoryComboBox.setNullSelectionAllowed(false);
		formLayout.addComponent(reportCategoryComboBox);

		formLayout.addComponent(beanFieldGroup.buildAndBind(i18n.get("Report.url"), "url"));

		beanFieldGroup.bindMemberFields(this);
	}
}
