package hu.oroscom.c1801.component.form;

import com.vaadin.data.Container;
import com.vaadin.data.fieldgroup.BeanFieldGroup;
import com.vaadin.data.fieldgroup.FieldGroup;
import hu.oroscom.c1801.domain.Role;
import hu.oroscom.c1801.service.RoleService;
import hu.oroscom.c1801.util.UserUtil;

/**
 * Created by kollerk on 14. 11. 13..
 */
public class RoleForm extends BaseForm<Role, RoleService> {

	public RoleForm(Role entity, boolean isWindowedForm, Container... container) {
		super(entity, isWindowedForm, container);
	}

	@Override
	public void initMemberFields(final BeanFieldGroup<Role> beanFieldGroup, Container... container) {
		formLayout.addComponent(beanFieldGroup.buildAndBind(i18n.get("Role.name"), "roleName"));

		beanFieldGroup.addCommitHandler(new FieldGroup.CommitHandler() {
			@Override
			public void preCommit(FieldGroup.CommitEvent commitEvent) throws FieldGroup.CommitException {
				Role role = beanFieldGroup.getItemDataSource().getBean();
				role.setCustomer(UserUtil.getCustomer());
			}

			@Override
			public void postCommit(FieldGroup.CommitEvent commitEvent) throws FieldGroup.CommitException {

			}
		});
	}
}
