package hu.oroscom.c1801.component.form;

import com.vaadin.data.Container;
import com.vaadin.data.fieldgroup.BeanFieldGroup;
import com.vaadin.data.fieldgroup.FieldGroup;
import hu.oroscom.c1801.domain.Role;
import hu.oroscom.c1801.domain.ServiceGroup;
import hu.oroscom.c1801.service.RoleService;
import hu.oroscom.c1801.service.ServiceGroupService;
import hu.oroscom.c1801.util.UserUtil;

/**
 * Created by kollerk on 14. 11. 13..
 */
public class ServiceGroupForm extends BaseForm<ServiceGroup, ServiceGroupService> {

	public ServiceGroupForm(ServiceGroup entity, boolean isWindowedForm, Container... container) {
		super(entity, isWindowedForm, container);
	}

	@Override
	public void initMemberFields(final BeanFieldGroup<ServiceGroup> beanFieldGroup, Container... container) {
		formLayout.addComponent(beanFieldGroup.buildAndBind(i18n.get("ServiceGroup.name"), "name"));

		beanFieldGroup.addCommitHandler(new FieldGroup.CommitHandler() {
			@Override
			public void preCommit(FieldGroup.CommitEvent commitEvent) throws FieldGroup.CommitException {
				ServiceGroup serviceGroup = beanFieldGroup.getItemDataSource().getBean();
				serviceGroup.setCustomer(UserUtil.getCustomer());
			}

			@Override
			public void postCommit(FieldGroup.CommitEvent commitEvent) throws FieldGroup.CommitException {

			}
		});
	}
}
