package hu.oroscom.c1801.component.form;

import com.vaadin.data.Container;
import com.vaadin.data.fieldgroup.BeanFieldGroup;
import com.vaadin.data.fieldgroup.FieldGroup;
import com.vaadin.ui.TextArea;
import hu.oroscom.c1801.domain.StudyEntryData;
import hu.oroscom.c1801.service.StudyEntryDataService;
import hu.oroscom.c1801.util.UserUtil;

public class StudyEntryDataForm extends BaseForm<StudyEntryData, StudyEntryDataService> {

	public StudyEntryDataForm(StudyEntryData entity, boolean isWindowedForm, Container... container) {
		super(entity, isWindowedForm, container);
	}

	@Override
	public void initMemberFields(final BeanFieldGroup<StudyEntryData> beanFieldGroup, Container... container) {
		formLayout.addComponent(beanFieldGroup.buildAndBind(i18n.get("StudyEntryData.name"), "name"));
		formLayout.addComponent(beanFieldGroup.buildAndBind(i18n.get("StudyEntryData.dataKey"), "dataKey"));
		formLayout.addComponent(beanFieldGroup.buildAndBind(i18n.get("StudyEntryData.description"), "description", TextArea.class));

		beanFieldGroup.addCommitHandler(new FieldGroup.CommitHandler() {
			@Override
			public void preCommit(FieldGroup.CommitEvent commitEvent) throws FieldGroup.CommitException {
				StudyEntryData studyEntryData = beanFieldGroup.getItemDataSource().getBean();
				studyEntryData.setCustomer(UserUtil.getCustomer());
			}

			@Override
			public void postCommit(FieldGroup.CommitEvent commitEvent) throws FieldGroup.CommitException {

			}
		});
	}
}
