package hu.oroscom.c1801.converter;

import com.vaadin.data.util.converter.Converter;
import org.joda.time.DateTime;

import java.util.Date;
import java.util.Locale;

/**
 * Created by kollerk on 14. 11. 21..
 */
public class DateToJodaDateConverter implements Converter<Date, DateTime> {
	@Override
	public DateTime convertToModel(Date value, Class<? extends DateTime> targetType, Locale locale) throws ConversionException {
		if (value != null) {
			return new DateTime(value);
		}
		return null;
	}

	@Override
	public Date convertToPresentation(DateTime value, Class<? extends Date> targetType, Locale locale) throws ConversionException {
		if (value != null) {
			return value.toDate();
		}
		return null;
	}

	@Override
	public Class<DateTime> getModelType() {
		return DateTime.class;
	}

	@Override
	public Class<Date> getPresentationType() {
		return Date.class;
	}
}
