package hu.oroscom.c1801.converter;

import org.eclipse.persistence.mappings.DatabaseMapping;
import org.eclipse.persistence.mappings.converters.Converter;
import org.eclipse.persistence.mappings.foundation.AbstractDirectMapping;
import org.eclipse.persistence.sessions.Session;
import org.joda.time.DateTime;

import java.sql.Timestamp;

/**
 * Created by kollerk on 14. 11. 21..
 */
public class JodaDateTimeConverter implements Converter {
	@Override
	public Object convertObjectValueToDataValue(Object objectValue, Session session) {
		return objectValue == null ? null : new Timestamp(((DateTime) objectValue).getMillis());
	}

	@Override
	public Object convertDataValueToObjectValue(Object dataValue, Session session) {
		return dataValue == null ? null : new DateTime((Timestamp) dataValue);
	}

	@Override
	public boolean isMutable() {
		return false;
	}

	@Override
	public void initialize(DatabaseMapping mapping, Session session) {
		((AbstractDirectMapping) mapping).setFieldClassification(java.sql.Timestamp.class);
	}
}
