package hu.oroscom.c1801.converter;

import com.vaadin.data.util.converter.Converter;

import java.text.DecimalFormat;
import java.util.Locale;

/**
 * Created by kollerk on 14. 12. 04..
 */
public class StringToFloatConverter implements Converter<String, Float> {
	@Override
	public Float convertToModel(String value, Class<? extends Float> targetType, Locale locale) throws ConversionException {
		if (value != null && !value.isEmpty()) {
			return Float.valueOf(value);
		}
		return null;
	}

	@Override
	public String convertToPresentation(Float value, Class<? extends String> targetType, Locale locale) throws ConversionException {
		if (value != null) {
			DecimalFormat decimalFormat = new DecimalFormat("0.##");
			return decimalFormat.format(value);
		}
		return null;
	}

	@Override
	public Class<Float> getModelType() {
		return Float.class;
	}

	@Override
	public Class<String> getPresentationType() {
		return String.class;
	}
}
