package hu.oroscom.c1801.converter;

import com.vaadin.data.util.converter.Converter;

import java.util.Locale;

/**
 * Created by kollerk on 14. 12. 04..
 */
public class StringToIntegerConverter implements Converter<String, Integer> {
	@Override
	public Integer convertToModel(String value, Class<? extends Integer> targetType, Locale locale) throws ConversionException {
		if (value != null && !value.isEmpty()) {
			return Integer.valueOf(value);
		}
		return null;
	}

	@Override
	public String convertToPresentation(Integer value, Class<? extends String> targetType, Locale locale) throws ConversionException {
		if (value != null) {
			return value.toString();
		}
		return null;
	}

	@Override
	public Class<Integer> getModelType() {
		return Integer.class;
	}

	@Override
	public Class<String> getPresentationType() {
		return String.class;
	}
}
