package hu.oroscom.c1801.converter;

import com.vaadin.data.util.converter.Converter;

import java.util.Locale;


public class StringToLongConverter implements Converter<String, Long> {
	@Override
	public Long convertToModel(String value, Class<? extends Long> targetType, Locale locale) throws ConversionException {
		if (value != null && !value.isEmpty()) {
			return Long.valueOf(value);
		}
		return null;
	}

	@Override
	public String convertToPresentation(Long value, Class<? extends String> targetType, Locale locale) throws ConversionException {
		if (value != null) {
			return value.toString();
		}
		return null;
	}

	@Override
	public Class<Long> getModelType() {
		return Long.class;
	}

	@Override
	public Class<String> getPresentationType() {
		return String.class;
	}
}
