package hu.oroscom.c1801.domain;

import hu.oroscom.c1801.enumeration.ContactType;

import javax.persistence.Embeddable;
import javax.persistence.Enumerated;
import javax.persistence.Transient;
import javax.validation.constraints.Size;
import java.io.Serializable;

@Embeddable
public class Address implements Serializable {
	@Enumerated
	private ContactType contactType = ContactType.WORKING;

	@Size(max = 255)
	private String zip;

	@Size(max = 255)
	private String city;

	@Size(max = 255)
	private String street;

	@Size(max = 255)
	private String geoCoords;

	@Transient
	private String displayAddress;

	public Address() {
	}

	public Address(String zip, String city, String street) {
		this.zip = zip;
		this.city = city;
		this.street = street;
	}

	public ContactType getContactType() {
		return contactType;
	}

	public void setContactType(ContactType contactType) {
		this.contactType = contactType;
	}

	public String getZip() {
		return zip;
	}

	public void setZip(String zip) {
		this.zip = zip;
	}

	public String getCity() {
		return city;
	}

	public void setCity(String city) {
		this.city = city;
	}

	public String getStreet() {
		return street;
	}

	public void setStreet(String street) {
		this.street = street;
	}

	public String getGeoCoords() {
		return geoCoords;
	}

	public void setGeoCoords(String geoCoords) {
		this.geoCoords = geoCoords;
	}

	public String getDisplayAddress() {
		return displayAddress;
	}

	public void setDisplayAddress(String displayAddress) {
		this.displayAddress = displayAddress;
	}
}
