package hu.oroscom.c1801.domain;

import hu.oroscom.c1801.converter.JodaDateTimeConverter;
import org.joda.time.DateTime;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Lob;

@Entity
public class Complaint extends BaseEntity {

	private Patient patient;

	@Lob
	private String description;

	@Column(columnDefinition = "TIMESTAMP NULL DEFAULT NULL")
	@org.eclipse.persistence.annotations.Converter(name = "dateTimeConverter", converterClass = JodaDateTimeConverter.class)
	@org.eclipse.persistence.annotations.Convert("dateTimeConverter")
	private DateTime dateTime;

	public Patient getPatient() {
		return patient;
	}

	public void setPatient(Patient patient) {
		this.patient = patient;
	}

	public String getDescription() {
		return description;
	}

	public void setDescription(String description) {
		this.description = description;
	}

	public DateTime getDateTime() {
		return dateTime;
	}

	public void setDateTime(DateTime dateTime) {
		this.dateTime = dateTime;
	}
}
