package hu.oroscom.c1801.domain;

import hu.oroscom.c1801.enumeration.CustomerType;

import javax.persistence.Embedded;
import javax.persistence.Entity;
import javax.persistence.Enumerated;
import javax.persistence.OneToMany;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;
import java.util.List;

/**
 * Created by kollerk on 2014.10.06..
 */
@Entity
public class Customer extends BaseEntity {
	@NotNull
	@Size(min = 4, max = 255)
	private String name;

	@Embedded
	private Address address;

	@Embedded
	private Contact contact;

	@OneToMany(mappedBy = "customer")
	private List<User> users;

	@OneToMany(mappedBy = "customer")
	private List<Setting> settings;

	@OneToMany(mappedBy = "customer")
	private List<Role> roles;

	@OneToMany(mappedBy = "customer")
	private List<ServiceManagement> serviceManagements;

	@NotNull
	@Enumerated
	private CustomerType customerType = CustomerType.NORMAL;

	@OneToMany(mappedBy = "customer")
	private List<ServiceGroup> serviceGroups;

	@OneToMany(mappedBy = "customer")
	private List<StudyEntryData> studyEntryData;

	@OneToMany(mappedBy = "customer")
	private List<StudyEntry> studyEntry;

	@OneToMany(mappedBy = "customer")
	private List<UserComment> userComments;

	public Customer() {
		address = new Address();
		contact = new Contact();
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public Address getAddress() {
		return address;
	}

	public void setAddress(Address address) {
		this.address = address;
	}

	public Contact getContact() {
		return contact;
	}

	public void setContact(Contact contact) {
		this.contact = contact;
	}

	public List<User> getUsers() {
		return users;
	}

	public void setUsers(List<User> users) {
		this.users = users;
	}

	public List<Setting> getSettings() {
		return settings;
	}

	public void setSettings(List<Setting> settings) {
		this.settings = settings;
	}

	public List<Role> getRoles() {
		return roles;
	}

	public void setRoles(List<Role> roles) {
		this.roles = roles;
	}

	public CustomerType getCustomerType() {
		return customerType;
	}

	public void setCustomerType(CustomerType customerType) {
		this.customerType = customerType;
	}

	public List<ServiceManagement> getServiceManagements() {
		return serviceManagements;
	}

	public void setServiceManagements(List<ServiceManagement> serviceManagements) {
		this.serviceManagements = serviceManagements;
	}

	public List<ServiceGroup> getServiceGroups() {
		return serviceGroups;
	}

	public void setServiceGroups(List<ServiceGroup> serviceGroups) {
		this.serviceGroups = serviceGroups;
	}

	public List<StudyEntryData> getStudyEntryData() {
		return studyEntryData;
	}

	public void setStudyEntryData(List<StudyEntryData> studyEntryData) {
		this.studyEntryData = studyEntryData;
	}

	public List<StudyEntry> getStudyEntry() {
		return studyEntry;
	}

	public void setStudyEntry(List<StudyEntry> studyEntry) {
		this.studyEntry = studyEntry;
	}

	public List<UserComment> getUserComments() {
		return userComments;
	}

	public void setUserComments(List<UserComment> userComments) {
		this.userComments = userComments;
	}
}
