package hu.oroscom.c1801.domain;

import hu.oroscom.c1801.converter.JodaDateTimeConverter;
import org.joda.time.DateTime;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Lob;
import javax.persistence.ManyToOne;
import javax.validation.constraints.Size;

/**
 * Created by kollerk on 2014.10.06..
 */
@Entity
public class ExcelExportLog extends BaseEntity {

	@ManyToOne
	private Customer customer;

	@Column(columnDefinition = "TIMESTAMP NULL DEFAULT NULL")
	@org.eclipse.persistence.annotations.Converter(name = "dateTimeConverter", converterClass = JodaDateTimeConverter.class)
	@org.eclipse.persistence.annotations.Convert("dateTimeConverter")
	private DateTime exportDate;

	@Size(max = 255)
	private String exportedUserName;

	@Size(max = 255)
	private String viewName;

	private Integer exportedRowCount;

	@Lob
	private String exportedCsv;

	public Customer getCustomer() {
		return customer;
	}

	public void setCustomer(Customer customer) {
		this.customer = customer;
	}

	public DateTime getExportDate() {
		return exportDate;
	}

	public void setExportDate(DateTime exportDate) {
		this.exportDate = exportDate;
	}

	public String getExportedUserName() {
		return exportedUserName;
	}

	public void setExportedUserName(String exportedUserName) {
		this.exportedUserName = exportedUserName;
	}

	public String getViewName() {
		return viewName;
	}

	public void setViewName(String viewName) {
		this.viewName = viewName;
	}

	public Integer getExportedRowCount() {
		return exportedRowCount;
	}

	public void setExportedRowCount(Integer exportedRowCount) {
		this.exportedRowCount = exportedRowCount;
	}

	public String getExportedCsv() {
		return exportedCsv;
	}

	public void setExportedCsv(String exportedCsv) {
		this.exportedCsv = exportedCsv;
	}
}
