package hu.oroscom.c1801.domain;

import hu.oroscom.c1801.enumeration.Gender;
import hu.oroscom.c1801.enumeration.PatientStatus;
import hu.oroscom.c1801.enumeration.YesNo;

import javax.persistence.*;
import java.util.Set;


@Entity
public class Patient extends User {
	@ManyToOne
	private Doctor doctor;

	@OneToMany(mappedBy = "patient")
	private Set<StudyEntry> studyEntries;

	@ManyToMany(mappedBy = "patients")
	private Set<UserComment> userComments;

	@OneToMany(mappedBy = "patient")
	private Set<EatenFood> eatenFoods;

	@OneToMany(mappedBy = "patient")
	private Set<IntolerantMaterial> intolerantMaterials;

	@OneToMany(mappedBy = "patient")
	private Set<Complaint> complaints;

	@Enumerated
	private PatientStatus patientStatus;

	private String patientId;

	private Long patientRandomNr;

	private Integer patientAge;

	@Enumerated
	private Gender gender;

	@Enumerated
	private YesNo patientSelection;

	@Enumerated
	private YesNo patientExclusion;

	@Enumerated
	private YesNo patientRand;

	private String patientRandNr;

	@Enumerated
	private YesNo patientComplied;

	private Long patientInternalId;

	public Doctor getDoctor() {
		if (doctor != null) {
			doctor.setDisplayName();
		}
		return doctor;
	}

	public void setDoctor(Doctor doctor) {
		this.doctor = doctor;
	}

	public Set<StudyEntry> getStudyEntries() {
		return studyEntries;
	}

	public void setStudyEntries(Set<StudyEntry> studyEntries) {
		this.studyEntries = studyEntries;
	}

	public Set<EatenFood> getEatenFoods() {
		return eatenFoods;
	}

	public void setEatenFoods(Set<EatenFood> eatenFoods) {
		this.eatenFoods = eatenFoods;
	}

	public Set<IntolerantMaterial> getIntolerantMaterials() {
		return intolerantMaterials;
	}

	public void setIntolerantMaterials(Set<IntolerantMaterial> intolerantMaterials) {
		this.intolerantMaterials = intolerantMaterials;
	}

	public Set<Complaint> getComplaints() {
		return complaints;
	}

	public void setComplaints(Set<Complaint> complaints) {
		this.complaints = complaints;
	}

	public Set<UserComment> getUserComments() {
		return userComments;
	}

	public void setUserComments(Set<UserComment> userComments) {
		this.userComments = userComments;
	}

	public PatientStatus getPatientStatus() {

		return patientStatus;
	}

	public void setPatientStatus(PatientStatus patientStatus) {

		this.patientStatus = patientStatus;
	}

	public String getPatientId() {

		return patientId;
	}

	public void setPatientId(String patientId) {

		this.patientId = patientId;
	}

	public Long getPatientRandomNr() {

		return patientRandomNr;
	}

	public void setPatientRandomNr(Long patientRandomNr) {

		this.patientRandomNr = patientRandomNr;
	}

	public Integer getPatientAge() {

		return patientAge;
	}

	public void setPatientAge(Integer patientAge) {

		this.patientAge = patientAge;
	}

	public Gender getGender() {

		return gender;
	}

	public void setGender(Gender gender) {

		this.gender = gender;
	}

	public YesNo getPatientSelection() {

		return patientSelection;
	}

	public void setPatientSelection(YesNo patientSelection) {

		this.patientSelection = patientSelection;
	}

	public YesNo getPatientExclusion() {

		return patientExclusion;
	}

	public void setPatientExclusion(YesNo patientExclusion) {

		this.patientExclusion = patientExclusion;
	}

	public YesNo getPatientRand() {

		return patientRand;
	}

	public void setPatientRand(YesNo patientRand) {

		this.patientRand = patientRand;
	}

	public String getPatientRandNr() {

		return patientRandNr;
	}

	public void setPatientRandNr(String patientRandNr) {

		this.patientRandNr = patientRandNr;
	}

	public YesNo getPatientComplied() {

		return patientComplied;
	}

	public void setPatientComplied(YesNo patientComplied) {

		this.patientComplied = patientComplied;
	}

	public Long getPatientInternalId() {

		return patientInternalId;
	}

	public void setPatientInternalId(Long patientInternalId) {

		this.patientInternalId = patientInternalId;
	}

}
