package hu.oroscom.c1801.domain;

import com.vaadin.server.VaadinSession;
import hu.oroscom.c1801.converter.JodaDateTimeConverter;
import org.eclipse.persistence.annotations.Convert;
import org.joda.time.DateTime;
import org.joda.time.format.DateTimeFormat;
import org.joda.time.format.DateTimeFormatter;

import javax.persistence.Column;
import javax.persistence.Embeddable;
import javax.validation.constraints.NotNull;
import java.io.Serializable;

/**
 * Created by kollerk on 2014.10.06..
 */
@Embeddable
public class Period implements Serializable {
	@Column(columnDefinition = "TIMESTAMP NULL DEFAULT NULL")
	@org.eclipse.persistence.annotations.Converter(name = "dateTimeConverter", converterClass = JodaDateTimeConverter.class)
	@Convert("dateTimeConverter")
	@NotNull
	private DateTime startDate;

	@Column(columnDefinition = "TIMESTAMP NULL DEFAULT NULL")
	@org.eclipse.persistence.annotations.Converter(name = "dateTimeConverter", converterClass = JodaDateTimeConverter.class)
	@Convert("dateTimeConverter")
	@NotNull
	private DateTime endDate;

	public DateTime getStartDate() {
		return startDate;
	}

	public void setStartDate(DateTime startDate) {
		this.startDate = startDate;
	}

	public DateTime getEndDate() {
		return endDate;
	}

	public void setEndDate(DateTime endDate) {
		this.endDate = endDate;
	}

	@Override
	public String toString() {
		if (startDate != null && endDate != null) {
			DateTimeFormatter dateTimeFormatter = DateTimeFormat.shortDateTime().withLocale(VaadinSession.getCurrent().getLocale());
			return startDate.toString(dateTimeFormatter) + "-" + endDate.toString("HH:mm");
		}

		return super.toString();
	}
}
