package hu.oroscom.c1801.domain;

import hu.oroscom.c1801.enumeration.PermissionName;
import org.springframework.security.core.GrantedAuthority;

import javax.persistence.*;
import java.util.Objects;
import java.util.Set;

@Entity
public class Permission extends BaseEntity implements GrantedAuthority {
	@Enumerated(EnumType.STRING)
	private PermissionName permissionName;

	@ManyToMany(mappedBy = "permissions")
	private Set<Role> roles;

	public Permission() {}

	public Permission(PermissionName permissionName) {
		this.permissionName = permissionName;
	}

	public PermissionName getPermissionName() {
		return permissionName;
	}

	@Override
	public String getAuthority() {
		return permissionName.toString();
	}

	public Set<Role> getRoles() {
		return roles;
	}

	public void setRoles(Set<Role> roles) {
		this.roles = roles;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj) {
			return true;
		}
		if (obj == null) {
			return false;
		}

		if (obj instanceof PermissionName) {
			PermissionName other = (PermissionName) obj;
			return Objects.equals(getPermissionName(), other.toString());
		} else {
			if (getClass() != obj.getClass()) {
				return false;
			}

			Permission other = (Permission) obj;
			return Objects.equals(getPermissionName(), other.getPermissionName());
		}
	}
}
