package hu.oroscom.c1801.domain;

import hu.oroscom.c1801.changelog.ChangeLog;
import hu.oroscom.c1801.changelog.TrackChanges;
import hu.oroscom.c1801.changelog.TrackChangesListener;
import hu.oroscom.c1801.enumeration.ServiceManagementNature;
import hu.oroscom.c1801.enumeration.ServiceManagementStatus;
import hu.oroscom.c1801.enumeration.StudyEntryType;

import javax.persistence.*;
import javax.validation.constraints.NotNull;
import java.util.List;

@Entity
@EntityListeners(TrackChangesListener.class)
public class ServiceManagement extends BaseEntity {
	@TrackChanges
	@Lob
	private String description;

	@Lob
	private byte[] attachment;

	@TrackChanges
	private String attachmentFileName;

	private String attachmentMimeType;

	@TrackChanges
	@NotNull
	@Enumerated
	private ServiceManagementNature serviceManagementNature;

	@TrackChanges
	@NotNull
	@Enumerated
	private ServiceManagementStatus serviceManagementStatus;

	@TrackChanges
	@ManyToOne
	private User user;

	@TrackChanges
	@Enumerated
	private StudyEntryType studyEntryType;

	@OneToMany(mappedBy = "serviceManagement", orphanRemoval = true, cascade = CascadeType.ALL)
	private List<ServiceManagementComment> serviceManagementComments;

	@ManyToOne
	private Customer customer;

	@ChangeLog
	@Lob
	private String changeLog;

	public String getDescription() {
		return description;
	}

	public void setDescription(String description) {
		this.description = description;
	}

	public byte[] getAttachment() {
		return attachment;
	}

	public void setAttachment(byte[] attachement) {
		this.attachment = attachement;
	}

	public String getAttachmentFileName() {
		return attachmentFileName;
	}

	public void setAttachmentFileName(String attachmentFileName) {
		this.attachmentFileName = attachmentFileName;
	}

	public String getAttachmentMimeType() {
		return attachmentMimeType;
	}

	public void setAttachmentMimeType(String attachmentMimeType) {
		this.attachmentMimeType = attachmentMimeType;
	}

	public ServiceManagementNature getServiceManagementNature() {
		return serviceManagementNature;
	}

	public void setServiceManagementNature(ServiceManagementNature serviceManagementNature) {
		this.serviceManagementNature = serviceManagementNature;
	}

	public ServiceManagementStatus getServiceManagementStatus() {
		return serviceManagementStatus;
	}

	public void setServiceManagementStatus(ServiceManagementStatus serviceManagementStatus) {
		this.serviceManagementStatus = serviceManagementStatus;
	}

	public User getUser() {
		return user;
	}

	public void setUser(User user) {
		this.user = user;
	}

	public StudyEntryType getStudyEntryType() {
		return studyEntryType;
	}

	public void setStudyEntryType(StudyEntryType studyEntryType) {
		this.studyEntryType = studyEntryType;
	}

	public List<ServiceManagementComment> getServiceManagementComments() {
		return serviceManagementComments;
	}

	public void setServiceManagementComments(List<ServiceManagementComment> serviceManagementComments) {
		this.serviceManagementComments = serviceManagementComments;
	}

	public Customer getCustomer() {
		return customer;
	}

	public void setCustomer(Customer customer) {
		this.customer = customer;
	}

	public String getChangeLog() {
		return changeLog;
	}

	public void setChangeLog(String changeLog) {
		this.changeLog = changeLog;
	}
}
