package hu.oroscom.c1801.domain;

import hu.oroscom.c1801.converter.JodaDateTimeConverter;
import hu.oroscom.c1801.domain.relationtable.StudyEntryStudyEntryData;
import hu.oroscom.c1801.enumeration.StudyEntryType;
import org.joda.time.DateTime;

import javax.persistence.*;
import java.util.HashSet;
import java.util.Set;

@Entity
public class StudyEntry extends BaseEntity {

	@Lob
	private String description;

	private Patient patient;

	@Enumerated
	private StudyEntryType studyEntryType;

	@Column(columnDefinition = "TIMESTAMP NULL DEFAULT NULL")
	@org.eclipse.persistence.annotations.Converter(name = "dateTimeConverter", converterClass = JodaDateTimeConverter.class)
	@org.eclipse.persistence.annotations.Convert("dateTimeConverter")
	private DateTime time;

	@Column(columnDefinition = "TIMESTAMP NULL DEFAULT NULL")
	@org.eclipse.persistence.annotations.Converter(name = "dateTimeConverter", converterClass = JodaDateTimeConverter.class)
	@org.eclipse.persistence.annotations.Convert("dateTimeConverter")
	private DateTime testDateTime;

	@ManyToMany(mappedBy = "studyEntries")
	private Set<StudyEntryData> studyEntryData;

	@ManyToOne
	private Customer customer;

	@OneToMany(mappedBy = "studyEntry", cascade = CascadeType.ALL, orphanRemoval = true)
	private Set<StudyEntryStudyEntryData> studyEntryStudyEntryData = new HashSet<>();

	public String getDescription() {
		return description;
	}

	public void setDescription(String description) {
		this.description = description;
	}

	public Patient getPatient() {
		return patient;
	}

	public void setPatient(Patient patient) {
		this.patient = patient;
	}

	public StudyEntryType getStudyEntryType() {
		return studyEntryType;
	}

	public void setStudyEntryType(StudyEntryType studyEntryType) {
		this.studyEntryType = studyEntryType;
	}

	public DateTime getTime() {
		return time;
	}

	public void setTime(DateTime time) {
		this.time = time;
	}

	public Set<StudyEntryData> getStudyEntryData() {
		return studyEntryData;
	}

	public void setStudyEntryData(Set<StudyEntryData> studyEntryData) {
		this.studyEntryData = studyEntryData;
	}

	public Customer getCustomer() {
		return customer;
	}

	public void setCustomer(Customer customer) {
		this.customer = customer;
	}

	public Set<StudyEntryStudyEntryData> getStudyEntryStudyEntryData() {
		return studyEntryStudyEntryData;
	}

	public void setStudyEntryStudyEntryData(HashSet<StudyEntryStudyEntryData> studyEntryStudyEntryData) {
		this.studyEntryStudyEntryData = studyEntryStudyEntryData;
	}

	public DateTime getTestDateTime() {
		return testDateTime;
	}

	public void setTestDateTime(DateTime testDateTime) {
		this.testDateTime = testDateTime;
	}
}
