package hu.oroscom.c1801.domain.filter;

import hu.oroscom.c1801.domain.BaseEntity;
import hu.oroscom.c1801.domain.User;
import hu.oroscom.c1801.enumeration.FilterCategory;
import hu.oroscom.c1801.enumeration.FilterType;

import javax.persistence.*;
import javax.validation.constraints.NotNull;
import java.util.List;

/**
 * Created by Norbert on 2015.07.06..
 */

@Entity
@Inheritance(strategy = InheritanceType.SINGLE_TABLE)
public class Filter extends BaseEntity {
	private String filterName;
	private String quickSearch;
	private List<String> ids;

	@NotNull
	@Enumerated
	private FilterCategory filterCategory;

	@NotNull
	@Enumerated
	private FilterType filterType = FilterType.NORMAL;

	@ManyToOne
	private User user;

	public String getFilterName() {
		return filterName;
	}

	public void setFilterName(String filterName) {
		this.filterName = filterName;
	}

	public String getQuickSearch() {
		return quickSearch;
	}

	public void setQuickSearch(String quickSearch) {
		this.quickSearch = quickSearch;
	}

	public List<String> getIds() {
		return ids;
	}

	public void setIds(List<String> ids) {
		this.ids = ids;
	}

	public FilterCategory getFilterCategory() {
		return filterCategory;
	}

	public void setFilterCategory(FilterCategory filterCategory) {
		this.filterCategory = filterCategory;
	}

	public User getUser() {
		return user;
	}

	public void setUser(User user) {
		this.user = user;
	}

	public FilterType getFilterType() {
		return filterType;
	}

	public void setFilterType(FilterType filterType) {
		this.filterType = filterType;
	}
}
