package hu.oroscom.c1801.enumeration;

import com.vaadin.server.VaadinSession;
import hu.oroscom.c1801.Application;
import hu.oroscom.c1801.domain.filter.ExcelExportLogFilter;
import hu.oroscom.c1801.domain.filter.Filter;
import hu.oroscom.c1801.domain.filter.PatientFilter;
import hu.oroscom.c1801.domain.filter.ServiceManagementFilter;

/**
 * Created by kollerk on 2014.10.07..
 */
public enum FilterCategory {
	EXPORTED_EXCELS,
	PATIENT,
	SERVICE_MANAGEMENT,
	STUDY_ENTRY_DATA,
	SERVICE_GROUP,
	DOCTOR,
	ASSISTANT,
	STUDY_ENTRY,
	EATEN_FOOD,
	INTOLERANT_MATERIAL,
	COMPLAINT,
	USER_COMMENT;

	public String getCaption() {
		try {
			return Application.getApplicationContext().getMessage(this.getClass().getSimpleName() + "." + name(), null, VaadinSession.getCurrent().getLocale());
		} catch (Exception e) {
			return name();
		}
	}

	public int getId() {
		return ordinal();
	}

	public static <F extends Filter> FilterCategory getFromClass(Class<F> filterClass) {
		if (ExcelExportLogFilter.class.equals(filterClass)) {
			return EXPORTED_EXCELS;
		} else if (PatientFilter.class.equals(filterClass)) {
			return PATIENT;
		} else if (ServiceManagementFilter.class.equals(filterClass)) {
			return SERVICE_MANAGEMENT;
		}
		return null;
	}
}
