package hu.oroscom.c1801.enumeration;

import com.vaadin.server.VaadinSession;
import hu.oroscom.c1801.Application;

import java.util.HashMap;
import java.util.Map;
import java.util.NoSuchElementException;

/**
 * Created by Norbert on 2015.07.07..
 */
public enum FilterOperand {
	EQUAL_TO("EQUAL_TO"),
	GREATER_THAN("GREATER_THAN"),
	LESS_THAN("LESS_THAN"),
	DIFFERENT_FROM("DIFFERENT_FROM"),
	CONTAINS("CONTAINS"),
	DOES_NOT_CONTAIN("DOES_NOT_CONTAIN"),
	STARTS_WITH("STARTS_WITH"),
	ENDS_WITH("ENDS_WITH"),
	INTERVAL("INTERVAL");

	private static final Map<String, FilterOperand> map = new HashMap<>();

	static {
		for (FilterOperand filterOperand : FilterOperand.values()) {
			map.put(filterOperand.stringValue, filterOperand);
		}
	}

	private final String stringValue;

	FilterOperand(final String s) {
		stringValue = s;
	}

	public static FilterOperand fromString(String stringValue) {
		if (map.containsKey(stringValue)) {
			return map.get(stringValue);
		}
		throw new NoSuchElementException(stringValue + " not found");
	}

	public String getCaption() {
		try {
			return Application.getApplicationContext().getMessage(this.getClass().getSimpleName() + "." + name(), null, VaadinSession.getCurrent().getLocale());
		} catch (Exception e) {
			return name();
		}
	}

	@Override
	public String toString() {
		return stringValue;
	}
}
