package hu.oroscom.c1801.enumeration;

import com.vaadin.server.VaadinSession;
import hu.oroscom.c1801.Application;

import java.util.HashMap;
import java.util.Map;
import java.util.NoSuchElementException;

/**
 * Created by Norbert on 2014.11.03..
 */
public enum PermissionName {
	PERM_NO_PERMISSION_NEEDED("PERM_NO_PERMISSION_NEEDED"),
	PERM_SERVICE_MANAGEMENT_SELECT_ANY("PERM_SERVICE_MANAGEMENT_SELECT_ANY"),
	PERM_SERVICE_MANAGEMENT_UPDATE_ANY("PERM_SERVICE_MANAGEMENT_UPDATE_ANY"),
	PERM_SERVICE_MANAGEMENT_CREATE_ANY("PERM_SERVICE_MANAGEMENT_CREATE_ANY"),
	PERM_SERVICE_MANAGEMENT_DELETE_ANY("PERM_SERVICE_MANAGEMENT_DELETE_ANY"),
	PERM_USER_SELECT_ANY("PERM_USER_SELECT_ANY"),
	PERM_USER_UPDATE_ANY("PERM_USER_UPDATE_ANY"),
	PERM_USER_CREATE_ANY("PERM_USER_CREATE_ANY"),
	PERM_USER_DELETE_ANY("PERM_USER_DELETE_ANY"),
	PERM_SETTINGS_VIEW("PERM_SETTINGS_VIEW"),
	PERM_SETTINGS_UPDATE("PERM_SETTINGS_UPDATE"),
	PERM_REPORT_SELECT_ANY("PERM_REPORT_SELECT_ANY"),
	PERM_DASHBOARD_VIEW("PERM_DASHBOARD_VIEW"),
	PERM_ROLE_SELECT_ANY("PERM_ROLE_SELECT_ANY"),
	PERM_ROLE_CREATE_ANY("PERM_ROLE_CREATE_ANY"),
	PERM_ROLE_DELETE_ANY("PERM_ROLE_DELETE_ANY"),
	PERM_ROLE_UPDATE_ANY("PERM_ROLE_UPDATE_ANY"),
	PERM_SERVICE_GROUP_SELECT_ANY("PERM_SERVICE_GROUP_SELECT_ANY"),
	PERM_SERVICE_GROUP_CREATE_ANY("PERM_SERVICE_GROUP_CREATE_ANY"),
	PERM_SERVICE_GROUP_DELETE_ANY("PERM_SERVICE_GROUP_DELETE_ANY"),
	PERM_SERVICE_GROUP_UPDATE_ANY("PERM_SERVICE_GROUP_UPDATE_ANY"),
	PERM_STUDY_ENTRY_SELECT_ANY("PERM_STUDY_ENTRY_SELECT_ANY"),
	PERM_STUDY_ENTRY_CREATE_ANY("PERM_STUDY_ENTRY_CREATE_ANY"),
	PERM_STUDY_ENTRY_DELETE_ANY("PERM_STUDY_ENTRY_DELETE_ANY"),
	PERM_STUDY_ENTRY_UPDATE_ANY("PERM_STUDY_ENTRY_UPDATE_ANY"),
	PERM_PATIENT_SELECT_ANY("PERM_PATIENT_SELECT_ANY"),
	PERM_PATIENT_UPDATE_ANY("PERM_PATIENT_UPDATE_ANY"),
	PERM_PATIENT_CREATE_ANY("PERM_PATIENT_CREATE_ANY"),
	PERM_PATIENT_DELETE_ANY("PERM_PATIENT_DELETE_ANY"),
	PERM_DOCTOR_SELECT_ANY("PERM_DOCTOR_SELECT_ANY"),
	PERM_DOCTOR_UPDATE_ANY("PERM_DOCTOR_UPDATE_ANY"),
	PERM_DOCTOR_CREATE_ANY("PERM_DOCTOR_CREATE_ANY"),
	PERM_DOCTOR_DELETE_ANY("PERM_DOCTOR_DELETE_ANY"),
	PERM_ASSISTANT_SELECT_ANY("PERM_ASSISTANT_SELECT_ANY"),
	PERM_ASSISTANT_UPDATE_ANY("PERM_ASSISTANT_UPDATE_ANY"),
	PERM_ASSISTANT_CREATE_ANY("PERM_ASSISTANT_CREATE_ANY"),
	PERM_ASSISTANT_DELETE_ANY("PERM_ASSISTANT_DELETE_ANY"),
	PERM_EATEN_FOOD_SELECT_ANY("PERM_EATEN_FOOD_SELECT_ANY"),
	PERM_EATEN_FOOD_UPDATE_ANY("PERM_EATEN_FOOD_UPDATE_ANY"),
	PERM_EATEN_FOOD_CREATE_ANY("PERM_EATEN_FOOD_CREATE_ANY"),
	PERM_EATEN_FOOD_DELETE_ANY("PERM_EATEN_FOOD_DELETE_ANY"),
	PERM_STUDY_ENTRY_DATA_SELECT_ANY("PERM_STUDY_ENTRY_DATA_SELECT_ANY"),
	PERM_STUDY_ENTRY_DATA_CREATE_ANY("PERM_STUDY_ENTRY_DATA_CREATE_ANY"),
	PERM_STUDY_ENTRY_DATA_DELETE_ANY("PERM_STUDY_ENTRY_DATA_DELETE_ANY"),
	PERM_STUDY_ENTRY_DATA_UPDATE_ANY("PERM_STUDY_ENTRY_DATA_UPDATE_ANY"),
	PERM_INTOLERANT_MATERIAL_SELECT_ANY("PERM_INTOLERANT_MATERIAL_SELECT_ANY"),
	PERM_INTOLERANT_MATERIAL_UPDATE_ANY("PERM_INTOLERANT_MATERIAL_UPDATE_ANY"),
	PERM_INTOLERANT_MATERIAL_CREATE_ANY("PERM_INTOLERANT_MATERIAL_CREATE_ANY"),
	PERM_INTOLERANT_MATERIAL_DELETE_ANY("PERM_INTOLERANT_MATERIAL_DELETE_ANY"),
	PERM_COMPLAINT_SELECT_ANY("PERM_COMPLAINT_SELECT_ANY"),
	PERM_COMPLAINT_UPDATE_ANY("PERM_COMPLAINT_UPDATE_ANY"),
	PERM_COMPLAINT_CREATE_ANY("PERM_COMPLAINT_CREATE_ANY"),
	PERM_COMPLAINT_DELETE_ANY("PERM_COMPLAINT_DELETE_ANY"),
	PERM_USER_COMMENT_SELECT_ANY("PERM_USER_COMMENT_SELECT_ANY"),
	PERM_USER_COMMENT_UPDATE_ANY("PERM_USER_COMMENT_UPDATE_ANY"),
	PERM_USER_COMMENT_CREATE_ANY("PERM_USER_COMMENT_CREATE_ANY"),
	PERM_USER_COMMENT_DELETE_ANY("PERM_USER_COMMENT_DELETE_ANY");

	private static final Map<String, PermissionName> map = new HashMap<>();

	static {
		for (PermissionName settingName : PermissionName.values()) {
			map.put(settingName.stringValue, settingName);
		}
	}

	private final String stringValue;

	private PermissionName(final String s) {
		stringValue = s;
	}

	public static PermissionName fromString(String stringValue) {
		if (map.containsKey(stringValue)) {
			return map.get(stringValue);
		}
		throw new NoSuchElementException(stringValue + " not found");
	}

	public String getCaption() {
		try {
			return Application.getApplicationContext().getMessage(this.getClass().getSimpleName() + "." + name(), null, VaadinSession.getCurrent().getLocale());
		} catch (Exception e) {
			return name();
		}
	}

	@Override
	public String toString() {
		return stringValue;
	}
}
