package hu.oroscom.c1801.enumeration;

import com.vaadin.server.VaadinSession;
import hu.oroscom.c1801.Application;

import java.util.HashMap;
import java.util.Map;
import java.util.NoSuchElementException;

/**
 * Created by Norbert on 2014.11.03..
 */
public enum RoleName {
	ROLE_SUPER_ADMIN("ROLE_SUPER_ADMIN"),
	ROLE_ADMIN("ROLE_ADMIN"),
	ROLE_DOCTOR("ROLE_DOCTOR"),
	ROLE_PATIENT("ROLE_PATIENT"),
	ROLE_ASSISTANT("ROLE_ASSISTANT"),
	ROLE_API("ROLE_API");

	private static final Map<String, RoleName> map = new HashMap<>();

	static {
		for (RoleName settingName : RoleName.values()) {
			map.put(settingName.stringValue, settingName);
		}
	}

	private final String stringValue;

	RoleName(final String s) {
		stringValue = s;
	}

	public static RoleName fromString(String stringValue) {
		if (map.containsKey(stringValue)) {
			return map.get(stringValue);
		}
		throw new NoSuchElementException(stringValue + " not found");
	}

	public String getCaption() {
		try {
			return Application.getApplicationContext().getMessage(this.getClass().getSimpleName() + "." + name(), null, VaadinSession.getCurrent().getLocale());
		} catch (Exception e) {
			return name();
		}
	}

	@Override
	public String toString() {
		return stringValue;
	}
}
