package hu.oroscom.c1801.enumeration;

import com.vaadin.server.VaadinSession;
import hu.oroscom.c1801.Application;

import java.util.HashMap;
import java.util.Map;
import java.util.NoSuchElementException;

/**
 * Created by Norbert on 2014.10.30..
 */
public enum SettingName {
	CUSTOMER_LOGO("customerLogo"),
	API_KEY("apiKey"),
	RESEARCH_STATUS("researchStatus"),
	PATIENT_DATA_IMPORT("patientDataImport");

	private final String stringValue;
	private static final Map<String, SettingName> map = new HashMap<>();

	static {
		for (SettingName settingName : SettingName.values()) {
			map.put(settingName.stringValue, settingName);
		}
	}

	private SettingName(final String s) {
		stringValue = s;
	}


	@Override
	public String toString() {
		return stringValue;
	}

	public static SettingName fromString(String stringValue) {
		if (map.containsKey(stringValue)) {
			return map.get(stringValue);
		}
		throw new NoSuchElementException(stringValue + " not found");
	}

	public String getCaption() {
		try {
			return Application.getApplicationContext().getMessage(this.getClass().getSimpleName() + "." + name(), null, VaadinSession.getCurrent().getLocale());
		} catch (Exception e) {
			return name();
		}
	}
}
