package hu.oroscom.c1801.jparepository;

import hu.oroscom.c1801.domain.BaseEntity;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.support.JpaEntityInformation;
import org.springframework.data.jpa.repository.support.JpaRepositoryFactory;
import org.springframework.data.jpa.repository.support.JpaRepositoryFactoryBean;
import org.springframework.data.repository.core.RepositoryMetadata;
import org.springframework.data.repository.core.support.RepositoryFactorySupport;

import javax.persistence.EntityManager;
import java.io.Serializable;

/**
 * Created by kollerk on 14. 11. 06..
 */
public class DefultRepositoryFactoryBean<R extends JpaRepository<T, I>, T, I extends Serializable>
		extends JpaRepositoryFactoryBean<R, T, I> {

//	protected RepositoryFactorySupport createRepositoryFactory(
//			EntityManager entityManager) {
//
//		return new DefaultRepositoryFactory(entityManager);
//	}


	protected RepositoryFactorySupport createRepositoryFactory(EntityManager entityManager) {

		return new MyRepositoryFactory(entityManager);
	}

	private static class MyRepositoryFactory<T extends BaseEntity, I extends Serializable> extends JpaRepositoryFactory {

		private EntityManager entityManager;

		public MyRepositoryFactory(EntityManager entityManager) {
			super(entityManager);

			this.entityManager = entityManager;
		}

		protected Object getTargetRepository(RepositoryMetadata metadata) {
			JpaEntityInformation<?, Serializable> entityInformation = getEntityInformation(metadata.getDomainType());
			return new GenericRepositoryImpl(entityInformation, entityManager);
		}

		protected Class<?> getRepositoryBaseClass(RepositoryMetadata metadata) {

			// The RepositoryMetadata can be safely ignored, it is used by the JpaRepositoryFactory
			//to check for QueryDslJpaRepository's which is out of scope.
			return GenericRepository.class;
		}
	}

}
