package hu.oroscom.c1801.jparepository;

import hu.oroscom.c1801.domain.User;
import hu.oroscom.c1801.domain.filter.Filter;
import hu.oroscom.c1801.enumeration.FilterCategory;
import org.springframework.data.jpa.repository.Query;

import java.util.List;

/**
 * Created by Norbert on 2015.06.11..
 */
public interface FilterRepository extends GenericRepository<Filter, Long> {
	@Query("SELECT f FROM Filter f WHERE f.user = ?1 AND f.filterCategory = ?2 ORDER BY f.id DESC")
//	@QueryHints({@QueryHint(name = "eclipselink.refresh", value = "true")})
	List<Filter> findAllFilterByUser(User user, FilterCategory filterCategory);

	@Query("SELECT f FROM Filter f WHERE f.user = ?2 AND f.filterCategory = ?1 ORDER BY f.filterName ASC")
	List<Filter> findAllByCategory(FilterCategory filterCategory, User user);
}
