package hu.oroscom.c1801.jparepository;

import hu.oroscom.c1801.domain.EntityBase;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.repository.NoRepositoryBean;

import javax.persistence.EntityManager;
import java.io.Serializable;
import java.util.HashMap;
import java.util.List;

/**
 * Created by kollerk on 14. 11. 06..
 */
@NoRepositoryBean
public interface GenericRepository<T extends EntityBase, ID extends Serializable> extends JpaRepository<T, ID> {
	List<T> callNamedStoredProcedureQuery(String procedureName, HashMap<String, ?> paramValues);

	void callNamedStoredProcedureUpdate(String procedureName, HashMap<String, ?> paramValues);

	T merge(T entity);

	List<T> executeQuery(String queryString, Class<T> aClass, HashMap<String, ?> parameterValues, int maxResults);

	EntityManager getEntityManager();
}
