package hu.oroscom.c1801.jparepository;

import hu.oroscom.c1801.domain.Permission;
import hu.oroscom.c1801.enumeration.PermissionName;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;

public interface PermissionRepository extends GenericRepository<Permission, Long> {
	@Query("select p from Permission p where p.permissionName = ?1")
	Permission findPermissionByName(PermissionName permissionName);

	@Modifying(clearAutomatically = true)
	@Query("delete from Permission p")
	void deleteAllPermission();
}
