package hu.oroscom.c1801.jparepository;

import hu.oroscom.c1801.domain.Customer;
import hu.oroscom.c1801.domain.Role;
import hu.oroscom.c1801.enumeration.RoleName;
import org.springframework.data.jpa.repository.Query;

import java.util.List;

public interface RoleRepository extends GenericRepository<Role, Long> {
	@Query("select r from Role r where r.roleName = ?1 AND r.customer = ?2")
	Role findRoleByName(String roleName, Customer customer);

	@Query("SELECT r FROM Role r WHERE r.customer = ?1 AND r.roleName NOT IN ?2")
	List<Role> findAllWithoutRole(Customer customer, RoleName... roleName);

	@Query("SELECT r FROM Role r WHERE r.customer = ?1 AND r.roleName IN ?2")
	List<Role> findAllWithRole(Customer customer, RoleName... roleName);

	@Query("SELECT r FROM Role r WHERE r.roleName = ?1")
	Role findSuperAdmin(String roleName);

	@Query("SELECT r FROM Role r WHERE r.customer = ?1")
	List<Role> findAllByCustomer(Customer customer);

	@Query("SELECT r FROM Role r WHERE r.roleName = hu.oroscom.c1801.enumeration.RoleName.ROLE_ADMIN")
	List<Role> findAllBySuperAdmin();
}
