package hu.oroscom.c1801.jparepository;

import hu.oroscom.c1801.domain.Customer;
import hu.oroscom.c1801.domain.StudyEntryBaseData;
import hu.oroscom.c1801.enumeration.StudyEntryType;
import org.springframework.data.jpa.repository.Query;

import java.util.List;
import java.util.Set;

public interface StudyEntryBaseDataRepository extends GenericRepository<StudyEntryBaseData, Long> {
	@Query("select sebd from StudyEntryBaseData sebd where sebd.customer = ?1")
	List<StudyEntryBaseData> findAllByCustomer(Customer customer);

	@Query("select sebd from StudyEntryBaseData sebd where sebd.customer = ?1 and sebd.studyEntryType in ?2")
	Set<StudyEntryBaseData> findAllByStudyEntryType(Customer customer, StudyEntryType... studyEntryTypes);

	@Query("select sebd from StudyEntryBaseData sebd where sebd.customer = ?1 and sebd.studyEntryType = ?2")
	StudyEntryBaseData findOneByStudyEntryType(Customer customer, StudyEntryType studyEntryTypes);
}
