package hu.oroscom.c1801.jparepository;

import hu.oroscom.c1801.domain.Customer;
import hu.oroscom.c1801.domain.Patient;
import hu.oroscom.c1801.domain.StudyEntry;
import hu.oroscom.c1801.enumeration.StudyEntryType;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.jpa.repository.QueryHints;

import javax.persistence.QueryHint;
import java.util.List;
import java.util.Set;

public interface StudyEntryRepository extends GenericRepository<StudyEntry, Long> {
	@Query("SELECT se FROM StudyEntry se WHERE se.patient = ?1")
	List<StudyEntry> findAllByPatient(Patient patient);

	@Query("select se from StudyEntry se where se.customer = ?1 and se.studyEntryType in ?2")
	Set<StudyEntry> findAllByStudyEntryType(Customer customer, StudyEntryType... studyEntryTypes);

	@QueryHints({@QueryHint(name = "eclipselink.refresh", value = "true")})
	@Query("select se from StudyEntry se left join fetch se.studyEntryData sed where se.id = ?1")
	StudyEntry findOneWithRelationTable(Long id);
}
