package hu.oroscom.c1801.jparepository;

import hu.oroscom.c1801.domain.Customer;
import hu.oroscom.c1801.domain.Doctor;
import hu.oroscom.c1801.domain.Patient;
import hu.oroscom.c1801.domain.UserComment;
import hu.oroscom.c1801.enumeration.UserCommentType;
import hu.oroscom.c1801.enumeration.Venue;
import org.springframework.data.jpa.repository.Query;

public interface UserCommentRepository extends GenericRepository<UserComment, Long> {
	@Query("select distinct count(uc) from UserComment uc inner join uc.patients p where p.venue = ?1 and uc.customer = ?2 and uc.userCommentType is null")
	int findAssistantUnmanagedCommentCount(Venue venue, Customer customer);

	@Query("select distinct count(uc) from UserComment uc where uc.userCommentType = ?1 and uc.doctor = ?2 and uc.customer = ?3")
	int findDoctorUnmanagedCommentCount(UserCommentType userCommentType, Doctor doctor, Customer customer);

	@Query("select distinct count(uc) from UserComment uc where (uc.userCommentType = ?1 or uc.userCommentType = ?2) and uc.patients in(?3) and uc.viewed = 0 and uc.customer = ?4")
	int findPatientUnseenAnsweredCommentCount(UserCommentType userCommentType, UserCommentType userCommentType2, Patient patient, Customer customer);
}
