package hu.oroscom.c1801.jparepository;

import hu.oroscom.c1801.domain.Customer;
import hu.oroscom.c1801.domain.Role;
import hu.oroscom.c1801.domain.User;
import hu.oroscom.c1801.enumeration.EntityStatus;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.jpa.repository.QueryHints;

import javax.persistence.QueryHint;
import java.util.List;

public interface UserRepository extends GenericRepository<User, Long> {
	@Query("select u from User u LEFT JOIN FETCH u.role r LEFT JOIN FETCH r.permissions where u.userName = ?1")
	User findUserByUserName(String userName);

	@Query("select u from User u where u.userName = ?1 and u.password = ?2 and u.status = ?3")
	User findByUserNameAndPassword(String userName, String password, EntityStatus entityStatus);

	@Query("select u from User u where u.role = ?1 ORDER BY LOWER(u.firstName), LOWER(u.lastName)")
	@QueryHints({@QueryHint(name = "eclipselink.refresh", value = "true")})
	List<User> findAllByRole(Role role);

	@Query("select u from User u where u.customer = ?1 AND u.status = ?2 ORDER BY LOWER(u.firstName), LOWER(u.lastName)")
	List<User> findAllByCustomer(Customer customer, EntityStatus entityStatus);

}
