package hu.oroscom.c1801.listener;

import com.vaadin.ui.Component;

import java.io.Serializable;
import java.lang.reflect.Method;

/**
 * Created by Norbert on 2015.09.22..
 */
public class ColumnCollapsedEvent extends Component.Event {
	private Component source;
	private Object propertyId;
	private boolean collapsed;
	public static final Method COLUMN_COLLAPSED_METHOD;

	public ColumnCollapsedEvent(Component source, Object propertyId, boolean collapsed) {
		super(source);
		this.source = source;
		this.propertyId = propertyId;
		this.collapsed = collapsed;
	}

	public Component getSource() {
		return source;
	}

	public boolean isCollapsed() {
		return collapsed;
	}

	public Object getPropertyId() {
		return this.propertyId;
	}

	static {
		try {
			COLUMN_COLLAPSED_METHOD = ColumnCollapsedEvent.ColumnCollapsedListener.class.getDeclaredMethod("columnCollapsed", new Class[]{ColumnCollapsedEvent.class});
		} catch (NoSuchMethodException var1) {
			throw new RuntimeException();
		}
	}

	public interface ColumnCollapsedListener extends Serializable {
		void columnCollapsed(ColumnCollapsedEvent columnCollapsedEvent);
	}
}
