package hu.oroscom.c1801.listener;

import com.vaadin.ui.Component;

import java.io.Serializable;
import java.lang.reflect.Method;

/**
 * Created by Norbert on 2015.09.22..
 */
public class ColumnSortEvent extends Component.Event {
	private Component source;
	private Object propertyId;
	private boolean sortAscending;
	public static final Method COLUMN_SORT_METHOD;

	public ColumnSortEvent(Component source, Object propertyId, boolean sortAscending) {
		super(source);
		this.source = source;
		this.propertyId = propertyId;
		this.sortAscending = sortAscending;
	}

	public Component getSource() {
		return source;
	}

	public boolean isSortAscending() {
		return sortAscending;
	}

	public Object getPropertyId() {
		return this.propertyId;
	}

	static {
		try {
			COLUMN_SORT_METHOD = ColumnSortEvent.ColumnSortListener.class.getDeclaredMethod("columnSort", new Class[]{ColumnSortEvent.class});
		} catch (NoSuchMethodException var1) {
			throw new RuntimeException();
		}
	}

	public interface ColumnSortListener extends Serializable {
		void columnSort(ColumnSortEvent columnSortEvent);
	}
}
