package hu.oroscom.c1801.listener;

import com.vaadin.server.*;
import hu.oroscom.c1801.ProjectSystemMessagesProvider;
import org.jsoup.nodes.Element;

import java.util.Locale;

/**
 * Created by Norbert on 2014.10.03..
 */
public class ProjectSessionInitListener implements SessionInitListener {
	@Override
	public void sessionInit(final SessionInitEvent event) throws ServiceException {
//		Locale locale = new Locale("hu", "HU");
		event.getSession().setLocale(VaadinSession.getCurrent().getLocale());
		Locale.setDefault(VaadinSession.getCurrent().getLocale());
		event.getService().setSystemMessagesProvider(
				new ProjectSystemMessagesProvider()
		);
		event.getSession().addBootstrapListener(new BootstrapListener() {

			@Override
			public void modifyBootstrapPage(final BootstrapPageResponse response) {
				final Element head = response.getDocument().head();
				head.appendElement("meta").attr("name", "viewport").attr("content", "width=device-width, initial-scale=1");
				head.appendElement("meta").attr("name", "apple-mobile-web-app-capable").attr("content", "yes");
				head.appendElement("meta").attr("name", "apple-mobile-web-app-status-bar-style").attr("content", "black");
			}

			@Override
			public void modifyBootstrapFragment(
					final BootstrapFragmentResponse response) {
				// TODO Auto-generated method stub
			}
		});
	}
}
