package hu.oroscom.c1801.service;

import hu.oroscom.c1801.domain.Customer;
import hu.oroscom.c1801.domain.Permission;
import hu.oroscom.c1801.domain.User;
import hu.oroscom.c1801.enumeration.CustomerType;
import hu.oroscom.c1801.enumeration.PermissionName;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.inject.Inject;

@Service
public class ContextService {

	@Inject
	RoleService roleService;

	@Inject
	PermissionService permissionService;

	@Inject
	UserService userService;

	@Inject
	CustomerService customerService;

	@Transactional
	public void initAuthorities() {
		int permissionCount = permissionService.findAll().size();
		int permissionNameCount = PermissionName.values().length;
		if (permissionNameCount > permissionCount) {
			for (PermissionName permissionName : PermissionName.values()) {
				Permission permission = permissionService.findPermissionByName(permissionName);
				if (permission == null) {
					permissionService.merge(new Permission(permissionName));
				}
			}
		}

		if (userService.findAll().isEmpty()) {
			createSa();
		}
	}

	private void createSa() {
		User user = new User();
		user.setFirstName("super");
		user.setLastName("admin");
		user.setShortName("sa");
		user.setUserName("sa");
		user.setPassword("da039904f941bce88727072c3cd047dc4433d047a506efbce1b5f0a7f789bd60942edffda649c1e3ff41c1236f704e7d7c42faab1af366587801506f9127d0fb");
		user.setCompany("OrosCom Kft.");
		user.setCustomer(createCustomer());
		user.setRole(roleService.findSuperAdmin());
		userService.merge(user);
	}

	private Customer createCustomer() {
		Customer customer = new Customer();
		customer.setName("Endomedix");
		customer.setCustomerType(CustomerType.PRIVATE_MEDICAL);
		return customerService.save(customer);
	}
}
