package hu.oroscom.c1801.service;

import hu.oroscom.c1801.domain.Customer;
import hu.oroscom.c1801.jparepository.CustomerRepository;
import org.springframework.stereotype.Service;

import javax.inject.Inject;
import java.util.List;

/**
 * Created by Norbert on 2014.10.29..
 */
@Service
public class CustomerService extends BaseService<Customer> {

	@Inject
	CustomerRepository customerRepository;

	@Inject
	RoleService roleService;

	@Override
	public Customer findOne(Long id) {
		return customerRepository.findOne(id);
	}

	@Override
	public Customer save(Customer entity) {
		Customer customer = customerRepository.save(entity);
		roleService.createDefaultRoles(customer);
		return customer;
	}

	@Override
	public List<Customer> save(Iterable<Customer> entities) {
		return customerRepository.save(entities);
	}

	@Override
	public List<Customer> findAll() {
		return customerRepository.findAll();
	}

	@Override
	public void delete(Customer entity) {
		customerRepository.delete(entity);
	}

	@Override
	public void delete(Long id) {
		customerRepository.delete(id);
	}

	@Override
	public void deleteAll() {
		customerRepository.deleteAll();
	}


}
