package hu.oroscom.c1801.service;

import hu.oroscom.c1801.domain.User;
import hu.oroscom.c1801.domain.filter.Filter;
import hu.oroscom.c1801.enumeration.FilterCategory;
import hu.oroscom.c1801.jparepository.FilterRepository;
import hu.oroscom.c1801.util.UserUtil;
import org.springframework.stereotype.Service;

import javax.inject.Inject;
import java.util.List;

/**
 * Created by Norbert on 2015.06.11..
 */
@Service
public class FilterService extends BaseService<Filter> {

	@Inject
	FilterRepository filterRepository;

	@Override
	public Filter save(Filter entity) {
		return filterRepository.save(entity);
	}

	@Override
	public List<Filter> save(Iterable<Filter> entities) {
		return filterRepository.save(entities);
	}

	@Override
	public Filter findOne(Long id) {
		return filterRepository.findOne(id);
	}

	@Override
	public List<Filter> findAll() {
		return filterRepository.findAll();
	}

	@Override
	public void delete(Filter entity) {
		filterRepository.delete(entity);
	}

	@Override
	public void delete(Long id) {
		filterRepository.delete(id);
	}

	@Override
	public void deleteAll() {
		filterRepository.deleteAll();
	}

	public <F extends Filter> List<F> findAllByUser(User user, FilterCategory filterCategory, Class<F> filterClass) {
		return (List<F>) filterRepository.findAllFilterByUser(user, filterCategory);
	}

	public List<Filter> findAllByCategory(FilterCategory filterCategory) {
		return filterRepository.findAllByCategory(filterCategory, UserUtil.getUser());
	}
}
