package hu.oroscom.c1801.service;

import hu.oroscom.c1801.domain.GridSetting;
import hu.oroscom.c1801.jparepository.GridSettingRepository;
import hu.oroscom.c1801.util.UserUtil;
import org.springframework.stereotype.Service;

import javax.inject.Inject;
import java.util.List;

/**
 * Created by Norbert on 2015.06.11..
 */
@Service
public class GridSettingService extends BaseService<GridSetting> {

	@Inject
	GridSettingRepository gridSettingRepository;

	@Override
	public GridSetting save(GridSetting entity) {
		return gridSettingRepository.save(entity);
	}

	@Override
	public List<GridSetting> save(Iterable<GridSetting> entities) {
		return gridSettingRepository.save(entities);
	}

	@Override
	public GridSetting findOne(Long id) {
		return gridSettingRepository.findOne(id);
	}

	@Override
	public List<GridSetting> findAll() {
		return gridSettingRepository.findAll();
	}

	@Override
	public void delete(GridSetting entity) {
		gridSettingRepository.delete(entity);
	}

	@Override
	public void delete(Long id) {
		gridSettingRepository.delete(id);
	}

	@Override
	public void deleteAll() {
		gridSettingRepository.deleteAll();
	}

	public GridSetting findGridSettingByGridName(String name) {
		return gridSettingRepository.findGridSettingByGridName(name, UserUtil.getUser());
	}
}
