package hu.oroscom.c1801.service;

import hu.oroscom.c1801.enumeration.PermissionName;
import hu.oroscom.c1801.domain.Permission;
import hu.oroscom.c1801.jparepository.PermissionRepository;
import org.springframework.stereotype.Service;

import javax.inject.Inject;
import java.util.List;

/**
 * Created by Norbert on 2014.11.20..
 */
@Service
public class PermissionService extends BaseService<Permission> {

	@Inject
	PermissionRepository permissionRepository;

	@Override
	public Permission save(Permission entity) {
		return permissionRepository.save(entity);
	}

	@Override
	public List<Permission> save(Iterable<Permission> entities) {
		return permissionRepository.save(entities);
	}

	@Override
	public Permission findOne(Long id) {
		return permissionRepository.findOne(id);
	}

	@Override
	public List<Permission> findAll() {
		return permissionRepository.findAll();
	}

	@Override
	public void delete(Permission entity) {
		permissionRepository.delete(entity);
	}

	@Override
	public void delete(Long id) {
		permissionRepository.delete(id);
	}

	@Override
	public void deleteAll() {
		permissionRepository.deleteAllPermission();
	}

	public Permission findPermissionByName(PermissionName permissionName) {
		return permissionRepository.findPermissionByName(permissionName);
	}

	public Permission merge(Permission permission) {
		return permissionRepository.merge(permission);
	}
}
