package hu.oroscom.c1801.service;

import hu.oroscom.c1801.domain.Report;
import hu.oroscom.c1801.enumeration.EntityStatus;
import hu.oroscom.c1801.enumeration.ReportCategory;
import hu.oroscom.c1801.jparepository.ReportRepository;
import org.springframework.stereotype.Service;
import org.vaadin.spring.i18n.I18N;

import javax.inject.Inject;
import java.util.List;

/**
 * Created by kollerk on 15. 02. 24..
 */
@Service
public class ReportService extends BaseService<Report> {

	@Inject
	ReportRepository reportRepository;

	@Inject
	I18N i18N;

	@Override
	public Report save(Report entity) {
		return reportRepository.save(entity);
	}

	@Override
	public List<Report> save(Iterable<Report> entities) {
		return reportRepository.save(entities);
	}

	@Override
	public Report findOne(Long id) {
		return reportRepository.findOne(id);
	}

	@Override
	public List<Report> findAll() {
		return reportRepository.findAll();
	}

	@Override
	public void delete(Report entity) {
		reportRepository.delete(entity);
	}

	@Override
	public void delete(Long id) {
		reportRepository.delete(id);
	}

	@Override
	public void deleteAll() {
		reportRepository.deleteAll();
	}

	public List<Report> findAllByCategory(ReportCategory reportCategory) {
		return reportRepository.findAllByCategory(reportCategory, EntityStatus.ACTIVE);
	}

}
