package hu.oroscom.c1801.service;

import hu.oroscom.c1801.domain.User;
import hu.oroscom.c1801.jparepository.UserRepository;
import org.springframework.security.core.userdetails.UserDetails;
import org.springframework.security.core.userdetails.UserDetailsService;
import org.springframework.security.core.userdetails.UsernameNotFoundException;
import org.springframework.stereotype.Service;

import javax.inject.Inject;

/**
 * Created by Norbert on 2014.10.22..
 */
@Service
public class SecurityService implements UserDetailsService {

	@Inject
	UserRepository userRepository;

	@Override
	public UserDetails loadUserByUsername(String username) throws UsernameNotFoundException {
		User user = userRepository.findUserByUserName(username);
		if (user == null) {
			throw new UsernameNotFoundException("UserName " + username + " not found");
		}
		return user;
	}
}
