package hu.oroscom.c1801.service;

import hu.oroscom.c1801.domain.Customer;
import hu.oroscom.c1801.domain.StudyEntryBaseData;
import hu.oroscom.c1801.enumeration.StudyEntryType;
import hu.oroscom.c1801.jparepository.StudyEntryBaseDataRepository;
import hu.oroscom.c1801.util.UserUtil;
import org.springframework.stereotype.Service;

import javax.inject.Inject;
import java.util.List;
import java.util.Set;

/**
 * Created by Norbert on 2014.10.29..
 */
@Service
public class StudyEntryBaseDataService extends BaseService<StudyEntryBaseData> {

	@Inject
	private StudyEntryBaseDataRepository studyEntryBaseDataRepository;

	@Override
	public StudyEntryBaseData findOne(Long id) {
		return studyEntryBaseDataRepository.findOne(id);
	}

	@Override
	public StudyEntryBaseData save(StudyEntryBaseData entity) {
		return studyEntryBaseDataRepository.save(entity);
	}

	@Override
	public List<StudyEntryBaseData> save(Iterable<StudyEntryBaseData> entities) {
		return studyEntryBaseDataRepository.save(entities);
	}

	@Override
	public List<StudyEntryBaseData> findAll() {
		return studyEntryBaseDataRepository.findAll();
	}

	@Override
	public void delete(StudyEntryBaseData entity) {
		studyEntryBaseDataRepository.delete(entity);
	}

	@Override
	public void delete(Long id) {
		studyEntryBaseDataRepository.delete(id);
	}

	@Override
	public void deleteAll() {
		studyEntryBaseDataRepository.deleteAll();
	}

	public List<StudyEntryBaseData> findAllByCustomer() {
		return studyEntryBaseDataRepository.findAllByCustomer(UserUtil.getCustomer());
	}

	public Set<StudyEntryBaseData> findAllByStudyEntryType(StudyEntryType... studyEntryTypes) {
		return studyEntryBaseDataRepository.findAllByStudyEntryType(UserUtil.getCustomer(), studyEntryTypes);
	}

	public StudyEntryBaseData findOneByStudyEntryType(StudyEntryType studyEntryType) {
		return studyEntryBaseDataRepository.findOneByStudyEntryType(UserUtil.getCustomer(), studyEntryType);
	}
	public StudyEntryBaseData findOneByStudyEntryType(Customer customer, StudyEntryType studyEntryType) {
		return studyEntryBaseDataRepository.findOneByStudyEntryType(customer, studyEntryType);
	}
}
