package hu.oroscom.c1801.util;

import org.joda.time.LocalDate;

/**
 * Created by ifino on 2017.02.13..
 */
public class DateTimeUtil {
	public static boolean hasWeekend(LocalDate fromDate, LocalDate toDate) {
		int fromDay = fromDate.getDayOfWeek();
		int daysToFirstWeekend = 6 - fromDay;
		LocalDate nextWeekend = fromDate.plusDays(daysToFirstWeekend);
		while (nextWeekend.isBefore(toDate)) {
			if (nextWeekend.plusDays(1).isBefore(toDate)) {
				return true;
			}
			nextWeekend = nextWeekend.plusDays(7);
		}
		return false;
	}

	public static int getWeekends(LocalDate fromDate, LocalDate toDate) {
		int weekends = 0;
		int fromDay = fromDate.getDayOfWeek();
		int daysToFirstWeekend = 6 - fromDay;
		LocalDate nextWeekend = fromDate.plusDays(daysToFirstWeekend);
		while (nextWeekend.isBefore(toDate)) {
			weekends++;
			if (nextWeekend.plusDays(1).isBefore(toDate)) {
				weekends++;
			}
			nextWeekend = nextWeekend.plusDays(7);
		}
		return weekends;
	}
}
