package hu.oroscom.c1801.util;

import com.vaadin.server.ErrorMessage;
import com.vaadin.server.Page;
import com.vaadin.ui.AbstractComponent;
import com.vaadin.ui.Notification;
import org.apache.commons.lang.StringUtils;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

/**
 * Created by Norbert on 2014.11.06..
 */
public class ErrorUtils {

	public static List<String> getComponentError(final AbstractComponent[] componentArray) {
		List<String> errorList = new ArrayList<>();

		for (AbstractComponent component : componentArray) {
			ErrorMessage errorMessage = component.getErrorMessage();
			if (errorMessage != null) {
				String errorMessageString = errorMessage.getFormattedHtmlMessage().replaceAll("<div>", "").replaceAll("</div>", "</br>");
				errorList.add(errorMessageString.substring(0, errorMessageString.length() - 6));
			}
		}

		return errorList;
	}

	public static List<String> getComponentError(final Collection<?> componentCollection) {
		AbstractComponent[] componentArray = componentCollection.toArray(new AbstractComponent[]{});
		return ErrorUtils.getComponentError(componentArray);
	}

	public static void showComponentErrors(String caption, final AbstractComponent[] componentArray) {
		List<String> errorList = ErrorUtils.getComponentError(componentArray);
//		String error = String.join("\n", errorList); java 8 only
		String error = StringUtils.join(errorList, "\n");
		Notification notification = new Notification(caption, error, Notification.Type.ERROR_MESSAGE, true);
		notification.show(Page.getCurrent());
	}

	public static void showComponentErrors(String caption, final Collection<?> componentCollection) {
		AbstractComponent[] componentArray = componentCollection.toArray(new AbstractComponent[]{});
		ErrorUtils.showComponentErrors(caption, componentArray);
	}
}
