package hu.oroscom.c1801.util;

import hu.oroscom.c1801.domain.EntityBase;
import hu.oroscom.c1801.domain.filter.Filter;
import hu.oroscom.c1801.enumeration.Action;

import java.util.Collection;

/**
 * Created by Norbert on 2015.04.14..
 */
public class EventBusAction<T extends EntityBase, F extends Filter> {
	private Action action;
	private Class<T> aClass;
	private T entity;
	private Collection<T> entities;
	private F filter;
	private boolean alreadyCalled = false;

	public EventBusAction(Action action) {
		this.action = action;
	}

	public EventBusAction(Action action, Class<T> aClass) {
		this.action = action;
		this.aClass = aClass;
	}

	public EventBusAction(Action action, T entity) {
		this.action = action;
		this.entity = entity;
	}

	public EventBusAction(Action action, Collection<T> entities) {
		this.action = action;
		this.entities = entities;
	}

	public EventBusAction(Action action, F filter) {
		this.action = action;
		this.filter = filter;
	}

	public Action getAction() {
		return action;
	}

	public void setAction(Action action) {
		this.action = action;
	}

	public T getEntity() {
		return entity;
	}

	public void setEntity(T entity) {
		this.entity = entity;
	}

	public F getFilter() {
		return filter;
	}

	public void setFilter(F filter) {
		this.filter = filter;
	}

	public Collection<T> getEntities() {
		return entities;
	}

	public void setEntities(Collection<T> entities) {
		this.entities = entities;
	}

	public Class<T> getaClass() {
		return aClass;
	}

	public void setaClass(Class<T> aClass) {
		this.aClass = aClass;
	}

	public boolean isAlreadyCalled() {
		return alreadyCalled;
	}

	public void setAlreadyCalled(boolean alreadyCalled) {
		this.alreadyCalled = alreadyCalled;
	}
}
