package hu.oroscom.c1801.util;

import hu.oroscom.c1801.domain.filter.Filter;
import hu.oroscom.c1801.enumeration.FilterOperand;

import java.lang.reflect.Field;

/**
 * Created by Norbert on 2015.07.10..
 */
public class FilterUtil {
	private final static String SEPARATOR = "<!:-->";

	public static String getFilterString(FilterOperand filterOperand, String filterValue) {
		return filterOperand.toString() + SEPARATOR + filterValue;
	}

	public static FilterItemBean getFilterItem(String filterString) {
		String[] filterStringItems = filterString.split(SEPARATOR);
		String operand;
		String value;
		if (filterStringItems.length < 1) {
			return null;
		} else if (filterStringItems.length == 1) {
			operand = filterStringItems[0];
			value = "";
		} else {
			operand = filterStringItems[0];
			value = filterStringItems[1];
		}
		return new FilterItemBean(FilterOperand.fromString(operand), value);
	}

	public static <F extends Filter> boolean isFilterActive(F filter) {
		for (Field field : filter.getClass().getDeclaredFields()) {
			field.setAccessible(true);
			Object value = null;
			try {
				value = field.get(filter);
			} catch (IllegalAccessException e) {
				e.printStackTrace();
			}
			if (value != null) {
				return true;
			}
		}

		try {
			Field quickSearchField = filter.getClass().getSuperclass().getDeclaredField("quickSearch");
			Field idsField = filter.getClass().getSuperclass().getDeclaredField("ids");
			quickSearchField.setAccessible(true);
			idsField.setAccessible(true);

			Object value = quickSearchField.get(filter);
			if (value != null) {
				return true;
			}

			value = idsField.get(filter);
			if (value != null) {
				return true;
			}
		} catch (NoSuchFieldException e) {
			e.printStackTrace();
		} catch (IllegalAccessException e) {
			e.printStackTrace();
		}

		return false;
	}
}
