package hu.oroscom.c1801.util;

import com.vaadin.server.VaadinSession;
import hu.oroscom.c1801.Application;
import hu.oroscom.c1801.domain.Customer;
import hu.oroscom.c1801.enumeration.CustomerType;
import org.vaadin.spring.i18n.I18N;

public class MessagesUtil {

	public static String get(I18N i18N, String message, Object... args) {
		Customer customer = UserUtil.getCustomer();

		if (customer == null) {
			return i18N.get(message, args);
		}

		CustomerType customerType = customer.getCustomerType();

		if (customerType == null || CustomerType.NORMAL.equals(customerType)) {
			return i18N.get(message, args);
		}

		if (CustomerType.PRIVATE_MEDICAL.equals(customerType)) {
			return i18N.getWithDefault(CustomerType.PRIVATE_MEDICAL + "." + message, i18N.get(message, args), args);
		}

		return i18N.get(message, args);
	}

	public static String getMessage(String s) {
		Customer customer = UserUtil.getCustomer();

		if (customer == null) {
			return Application.getApplicationContext().getMessage(s, null, VaadinSession.getCurrent().getLocale());
		}

		CustomerType customerType = customer.getCustomerType();

		if (customerType == null || CustomerType.NORMAL.equals(customerType)) {
			return Application.getApplicationContext().getMessage(s, null, VaadinSession.getCurrent().getLocale());
		}

		if (CustomerType.PRIVATE_MEDICAL.equals(customerType)) {
			String ret = Application.getApplicationContext().getMessage(CustomerType.PRIVATE_MEDICAL + "." + s, null, VaadinSession.getCurrent().getLocale());

			if (("!" + CustomerType.PRIVATE_MEDICAL + "." + s).equals(ret)) {
				return Application.getApplicationContext().getMessage(s, null, VaadinSession.getCurrent().getLocale());
			}
		}

		return Application.getApplicationContext().getMessage(s, null, VaadinSession.getCurrent().getLocale());
	}
}
