package hu.oroscom.c1801.view;

import com.vaadin.ui.Panel;
import com.vaadin.ui.TabSheet;
import hu.oroscom.c1801.domain.BaseEntity;
import hu.oroscom.c1801.service.BaseService;

/**
 * Created by kollerk on 14. 11. 27..
 */
public abstract class BaseTabSheetView<T extends BaseEntity, S extends BaseService, F extends Panel> extends BaseView {

	protected TabSheet tabSheet;
	protected F form;

	@Override
	protected void init() {
		tabSheet = new TabSheet();
		tabSheet.setSizeFull();

		addComponent(tabSheet);
		setExpandRatio(tabSheet, 1);

		setDataSource();
	}

	protected abstract void registerColumns();

	protected abstract void setDataSource();

}
