package hu.oroscom.c1801.view;

import com.vaadin.ui.Window;
import hu.oroscom.c1801.NeededAnyPermission;
import hu.oroscom.c1801.component.form.SettingsForm;
import hu.oroscom.c1801.enumeration.PermissionName;
import hu.oroscom.c1801.enumeration.SettingName;
import hu.oroscom.c1801.service.SettingService;
import org.vaadin.spring.annotation.VaadinUIScope;
import org.vaadin.spring.navigator.annotation.VaadinView;

import javax.inject.Inject;

/**
 * Created by Norbert on 2014.10.29..
 */
@VaadinUIScope
@VaadinView(name = SettingsView.NAME)
@NeededAnyPermission(values = {
		PermissionName.PERM_SETTINGS_VIEW,
		PermissionName.PERM_SETTINGS_UPDATE,
})
public class SettingsView extends BaseView {
	public static final String NAME = "settings";

	@Inject
	SettingService settingService;

	@Override
	protected void init() {
		super.defaultComponents(i18n.get("SettingsView.settingsLabel"));

		SettingsForm settingsForm = new SettingsForm(settingService.findSetting(
				SettingName.RESEARCH_STATUS,
				SettingName.API_KEY,
				SettingName.PATIENT_DATA_IMPORT,
				SettingName.CUSTOMER_LOGO
		));
		addComponent(settingsForm);
		setExpandRatio(settingsForm, 1);
		addStyleName("v-scrollable");
		setHeightUndefined();
	}

	@Override
	public void windowClose(Window.CloseEvent closeEvent) {

	}
}
