package hu.oroscom.c1801.webservice;

import hu.oroscom.c1801.service.TokenService;
import org.springframework.security.core.Authentication;
import org.springframework.security.web.authentication.SavedRequestAwareAuthenticationSuccessHandler;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;

/**
 * Created by kollerk on 15. 02. 05..
 */
public class AjaxAuthenticationSuccessHandler extends SavedRequestAwareAuthenticationSuccessHandler {

	@Override
	public void onAuthenticationSuccess(HttpServletRequest request, HttpServletResponse response, Authentication authentication) throws ServletException, IOException {
		//check if login is originated from ajax call
		if ("true".equals(request.getHeader("x-ajax-call"))) {
			try {
				String token = TokenService.createToken(request.getParameter("j_username"), request.getParameter("j_password"), Long.valueOf(request.getParameter("j_customer")));
				response.getWriter().print(token);//return "ok" string
				response.getWriter().flush();
			} catch (IOException e) {
				e.printStackTrace();
			}
		} else {
			setAlwaysUseDefaultTargetUrl(false);
		}
	}
}
