package hu.oroscom.c1801.webservice;

import org.apache.commons.codec.binary.Base64;
import org.springframework.http.*;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.client.RestTemplate;

/**
 * Created by kollerk on 15. 02. 23..
 */
@RestController
@RequestMapping(value = {"/api", "/client"})
public class ReportWebService {

	private HttpEntity<String> getHttpEntity4Auth() {
		String plainCreds = "jasperadmin:codeaccepted";
		byte[] plainCredsBytes = plainCreds.getBytes();
		byte[] base64CredsBytes = Base64.encodeBase64(plainCredsBytes);
		String base64Creds = new String(base64CredsBytes);

		HttpHeaders headers = new HttpHeaders();
		headers.add("Authorization", "Basic " + base64Creds);

		return new HttpEntity<>("parameters", headers);
	}

	@RequestMapping(value = "/reports/pdfreport", produces = "application/pdf")
	public byte[] runPDFReport(@RequestParam("url") String url) {

		RestTemplate restTemplate = new RestTemplate();

        ResponseEntity<byte[]> responseEntity = null;
        try {
            responseEntity = restTemplate.exchange("http://jrs.hu/rest_v2/reports/reports/" + url + ".pdf",
                    HttpMethod.GET,
                    getHttpEntity4Auth(),
                    byte[].class);

        } catch (Exception e) {
            //A riportszerver egy idő után 500-as hibát dob erlőször
            responseEntity = restTemplate.exchange("http://jrs.hu/rest_v2/reports/reports/" + url + ".pdf",
                    HttpMethod.GET,
                    getHttpEntity4Auth(),
                    byte[].class);
        } finally {
            if (responseEntity != null) {
                return responseEntity.getBody();
            } else {
                return "Error".getBytes();
            }
        }


	}

	@RequestMapping(value = "/reports/htmlreport", produces = MediaType.TEXT_HTML_VALUE)
	public String runHTMLReport(@RequestParam("url") String url) {

		RestTemplate restTemplate = new RestTemplate();

		ResponseEntity<String> responseEntity = restTemplate.exchange("http://jrs.hu/rest_v2/reports/reports/" + url + ".html", HttpMethod.GET, getHttpEntity4Auth(), String.class);

		return responseEntity.getBody();
	}
}
