package hu.oroscom.c1801.widgetset;

import com.vaadin.data.Property;
import com.vaadin.ui.DateField;
import hu.oroscom.c1801.widgetset.client.CustomDateFieldState;

import java.util.Arrays;
import java.util.Date;
import java.util.List;

/**
 * Created by Norbert on 2014.12.01..
 */
public class CustomDateField extends DateField {

	public CustomDateField() {
	}

	public CustomDateField(String caption) {
		super(caption);
	}

	public CustomDateField(String caption, Property dataSource) {
		super(caption, dataSource);
	}

	public CustomDateField(Property dataSource) throws IllegalArgumentException {
		super(dataSource);
	}

	public CustomDateField(String caption, Date value) {
		super(caption, value);
	}

	@Override
	protected CustomDateFieldState getState() {
		return (CustomDateFieldState) super.getState();
	}

	public Date[] getDisabledDates() {
		List<Date> disabledDates = getState().disabledDates;
		if (disabledDates == null || disabledDates.isEmpty()) {
			return new Date[0];
		}
		return disabledDates.toArray(new Date[disabledDates.size()]);
	}

	public void setDisabledDates(Date... dates) {
		getState().disabledDates = Arrays.asList(dates);
	}
}
