package hu.oroscom.c1801.widgetset;

import com.vaadin.data.Property;
import com.vaadin.ui.TextField;
import hu.oroscom.c1801.widgetset.client.NumberFieldState;

/**
 * Created by Norbert on 2014.11.10..
 */
public class NumberField extends TextField {

	/**
	 *
	 */
	private static final long serialVersionUID = 1L;

	public NumberField() {
		super();
	}

	public NumberField(Property<?> dataSource) {
		super(dataSource);
	}

	public NumberField(String caption, Property<?> dataSource) {
		super(caption, dataSource);
	}

	public NumberField(String caption, String value) {
		super(caption, value);
	}

	public NumberField(String caption) {
		super(caption);
	}

	@Override
	protected NumberFieldState getState() {
		return (NumberFieldState) super.getState();
	}

	/**
	 * @return the minimum number to be entered (or null for any number)
	 */
	public Integer getMin() {
		return getState().min;
	}

	/**
	 * @param min the minimum number to be entered (or null for any number)
	 */
	public void setMin(Integer min) {
		getState().min = min;
	}

	/**
	 * @return the maximum number to be entered (or null for any number)
	 */
	public Integer getMax() {
		return getState().max;
	}

	/**
	 * @param max the maximum number to be entered (or null for any number)
	 */
	public void setMax(Integer max) {
		getState().max = max;
	}

	/**
	 * @return the step for the number to be entered (or null for any number)
	 */
	public Integer getStep() {
		return getState().step;
	}

	/**
	 * @param step the step for the number to be entered (or null for any number)
	 */
	public void setStep(Integer step) {
		getState().step = step;
	}
}
