package hu.oroscom.c1801.widgetset.client;

import com.google.gwt.event.dom.client.KeyCodes;
import com.google.gwt.event.dom.client.KeyPressEvent;
import com.google.gwt.event.dom.client.KeyPressHandler;
import com.vaadin.client.ui.VTextField;

/**
 * Created by Norbert on 2014.11.10..
 */
public class NumberFieldWidget extends VTextField {

	public static final String CLASSNAME = "v-numberfield";

	private KeyPressHandler keyPressHandler = new KeyPressHandler() {
		@Override
		public void onKeyPress(KeyPressEvent keyPressEvent) {
			if (isReadOnly() || !isEnabled()) {
				return;
			}

			int keyCode = keyPressEvent.getNativeEvent().getKeyCode();
			if (isControlKey(keyCode) || keyPressEvent.isAnyModifierKeyDown()) {
				return;
			}

			if (!isNumberKey(keyCode)) {
				cancelKey();
			}
		}

	};

	public NumberFieldWidget() {
		addStyleName(CLASSNAME);
		getElement().setPropertyString("type", "number");
		addKeyPressHandler(keyPressHandler);
	}

	public void setMin(Integer min) {
		if (min == null) {
			getElement().setPropertyString("min", "");
		} else {
			getElement().setPropertyString("min", min.toString());
		}
	}

	public void setMax(Integer max) {
		if (max == null) {
			getElement().setPropertyString("max", "");
		} else {
			getElement().setPropertyString("max", max.toString());
		}
	}

	public void setStep(Integer step) {
		if (step == null) {
			getElement().setPropertyString("step", "");
		} else {
			getElement().setPropertyString("step", step.toString());
		}
	}

	private boolean isControlKey(int keyCode) {
		switch (keyCode) {
			case KeyCodes.KEY_LEFT:
			case KeyCodes.KEY_RIGHT:
			case KeyCodes.KEY_UP:
			case KeyCodes.KEY_DOWN:
			case KeyCodes.KEY_BACKSPACE:
			case KeyCodes.KEY_DELETE:
			case KeyCodes.KEY_TAB:
			case KeyCodes.KEY_ENTER:
			case KeyCodes.KEY_ESCAPE:
			case KeyCodes.KEY_HOME:
			case KeyCodes.KEY_END:
				return true;
		}

		return false;
	}

	private boolean isNumberKey(int keyCode) {
		switch (keyCode) {
			case KeyCodes.KEY_ZERO:
			case KeyCodes.KEY_ONE:
			case KeyCodes.KEY_TWO:
			case KeyCodes.KEY_THREE:
			case KeyCodes.KEY_FOUR:
			case KeyCodes.KEY_FIVE:
			case KeyCodes.KEY_SIX:
			case KeyCodes.KEY_SEVEN:
			case KeyCodes.KEY_EIGHT:
			case KeyCodes.KEY_NINE:
				return true;
		}

		return false;
	}
}
